<?php
class PowerBBFunctions
{

	/**
	 * Get sections list from cache and show it.
	 */

	function _GetSections()
	{
		global $PowerBB;

		$SecArr 						= 	array();
		$SecArr['get_from']				=	'db';

		$SecArr['proc'] 				= 	array();
		$SecArr['proc']['*'] 			= 	array('method'=>'clean','param'=>'html');

		$SecArr['order']				=	array();
		$SecArr['order']['field']		=	'sort';
		$SecArr['order']['type']		=	'ASC';

		$SecArr['where']				=	array();
		$SecArr['where'][0]['name']		= 	'parent';
		$SecArr['where'][0]['oper']		= 	'=';
		$SecArr['where'][0]['value']	= 	'0';

		// Get main sections
		$cats = $PowerBB->core->GetList($SecArr,'section');
 		////////////

		// Loop to read the information of main sections
		foreach ($cats as $cat)
		{
         if (!file_exists("cache/sectiongroup_cache".$cat['id'].".php"))
         {
				//$PowerBB->functions->_AllCacheStart();
				//$PowerBB->functions->_MeterGroupsStart();
         }
			//////////////////////////

			@include("cache/sectiongroup_cache".$cat['id'].".php");
	       // Get the groups information to know view this section or not
	      $sectiongroup = unserialize(base64_decode($sectiongroup_cache['sectiongroup_cache']));
		  if ($sectiongroup[$PowerBB->_CONF['group_info']['id']]['view_section'])
	      {
             // foreach main sections
			$PowerBB->_CONF['template']['foreach']['forums_list'][$cat['id'] . '_m'] = $cat;

			unset($sectiongroup);

			@include("cache/forums_cache_".$cat['id'].".php");
			if (!empty($forums_cache['forums_cache']))
			{
                $forums = unserialize(base64_decode($forums_cache['forums_cache']));

					foreach ($forums as $forum)
					{
						//////////////////////////
					     @include("cache/sectiongroup_cache".$forum['id'].".php");
						$groups = unserialize(base64_decode($sectiongroup_cache['sectiongroup_cache']));
						if ($groups[$PowerBB->_CONF['group_info']['id']]['view_section'])
						{
                           if (!empty($forum['last_date']))
                           {
							$forum_last_time1 = $forum['last_date'];
							$forum['last_subject'] = $PowerBB->Powerparse->censor_words($forum['last_subject']);
							$forum['last_subject'] =  $PowerBB->Powerparse->_wordwrap($forum['last_subject'],'60');
							$forum['last_post_date'] = $forum['last_time'];
							$forum['last_date'] = $PowerBB->sys_functions->time_ago($forum_last_time1);
							$forum['last_subjectid'] = $forum['last_subjectid'];
							$forum['last_time'] = $forum['last_time'];
							$forum['last_reply'] = $forum['last_reply'];
							$forum['icon'] = $forum['icon'];
							$forum['review_subject'] = $forum['review_subject'];
							$forum['last_berpage_nm'] = $forum['last_berpage_nm'];
							$forum['last_writer']= $forum['last_writer'];
							$forum['last_subject'] =  stripslashes($forum['last_subject']);
                           }
                            $forum['subject_num'] = $PowerBB->functions->with_comma($forum['subject_num']);
                            $forum['reply_num'] = $PowerBB->functions->with_comma($forum['reply_num']);

							// Get the number of subjects and replys hidden for Moderators
							if ($PowerBB->functions->ModeratorCheck($forum['id']))
							{
				               if ($forum['subjects_review_num']>0)
								{
								$forum['num_subjects_awaiting_approval'] =	$PowerBB->functions->with_comma($forum['subjects_review_num']);
								}
	                           if ($forum['replys_review_num']>0)
								{
								$forum['num_replys_awaiting_approval'] =	$PowerBB->functions->with_comma($forum['replys_review_num']);
								}
					        }


		                    if ($PowerBB->_CONF['info_row']['no_sub'])
						    {
								$forum['is_sub'] 	= 	0;
								$forum['sub']		=	'';

										$t=0;
										$forum['sub'] .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\"><tr valign=\"top\"> ";
			                        @include("cache/forums_cache_".$forum['id'].".php");
                                   if (!empty($forums_cache['forums_cache']))
		                           {

										$subs = unserialize(base64_decode($forums_cache['forums_cache']));
		                               foreach($subs as $sub)
										{
										   if ($forum['id'] == $sub['parent'])
		                                    {
									            @include("cache/sectiongroup_cache".$sub['id'].".php");
										        $groups = unserialize(base64_decode($sectiongroup_cache['sectiongroup_cache']));

										        if (!empty($sub['last_date']))
										         {
										           if ($forum['last_time']< $sub['last_time'])
										           {
	                                             	$forum_last_time1 = $sub['last_date'];
													$forum['last_subject'] = $PowerBB->Powerparse->censor_words($sub['last_subject']);
													$forum['last_subject'] =  $PowerBB->Powerparse->_wordwrap($sub['last_subject'],'60');
													$forum['last_post_date'] = $sub['last_time'];
				                                    if($sub['subject_num'] > 0)
				                                    {
													$forum['last_date'] = $PowerBB->sys_functions->time_ago($forum_last_time1);
	                                                }
													$forum['last_subjectid'] = $sub['last_subjectid'];
													$forum['last_time'] = $sub['last_time'];
													$forum['last_reply'] = $sub['last_reply'];
													$forum['icon'] = $sub['icon'];
													$forum['review_subject'] = $sub['review_subject'];
													$forum['last_berpage_nm'] = $sub['last_berpage_nm'];
													$forum['last_writer']= $sub['last_writer'];
								                    $forum['last_subject'] =  stripslashes($sub['last_subject']);
								                  }
                                               }
			                                        $forum_subject_num = $forum['subject_num']+ $sub['subject_num'];
			                                        $forum_reply_num =  $forum['reply_num']+ $sub['reply_num'];
			                                        $forum['subject_num']   = $PowerBB->functions->with_comma($forum_subject_num);
			                                        $forum['reply_num']   = $PowerBB->functions->with_comma($forum_reply_num);

												  if ($groups[$PowerBB->_CONF['group_info']['id']]['view_section'])
												   {
														 $forum_title_color = "'".$sub['forum_title_color']."'";
														 $sub['title'] = "<font color=".$forum_title_color.">".stripslashes($sub['title'])."</font>";
														if ($sub['id'])
														{
														$forum['is_sub'] = 1;
														}
														if($t== $PowerBB->_CONF['info_row']['sub_columns_number']){
														$t=0;
														$forum['sub'] .="</tr><tr>";
														}
														$forum_url = "index.php?page=forum&amp;show=1&amp;id=";
														$forum['sub'] .= "<td>";
														$forum['sub'] .= '<a href="'.$PowerBB->functions->rewriterule($forum_url).$sub['id'].'"><img border="0" alt="" src="' . $PowerBB->_CONF['template']['image_path'] . '/address_bar_start.gif" />'.$sub['title'].'</a>';
														$forum['sub'] .= "&nbsp;</td>";
														$t=$t+1;

											        }
											  }
										 }
									    	$forum['sub'] .="</tr></table>";


								   }
		                     }
						   //////////


							// get writer username style cache And  writer photo
	                         $username = $forum['last_writer'];
	                      if ($username !='Guest')
                            {
							   if ($PowerBB->_CONF['info_row']['get_group_username_style'])
							     {
									if (!empty($username))
									{
							   		// Get username style
									$MemberArr 			= 	array();
									$MemberArr['where'] 	= 	array('username',$username);

									$StyleMemberInfo = $PowerBB->core->GetInfo($MemberArr,'member');
							        $username = $StyleMemberInfo['username_style_cache'];
							        $user_id = $StyleMemberInfo['id'];
									if ($PowerBB->_CONF['info_row']['allow_avatar'])
									{
                                       // Get writer photo
								        if (!$StyleMemberInfo['avater_path'])
								        {
							            $avater_path = $PowerBB->_CONF['template']['image_path'].'/'.$PowerBB->_CONF['info_row']['default_avatar'];
							            }
							            else
								        {
							            $avater_path = $StyleMemberInfo['avater_path'];
							            }
									   $writer_photo_thumb = '<a href="index.php?page=profile&amp;show=1&amp;id=' . $user_id . '"><img src="' . $avater_path . '" alt="photo" class="UserPhoto_mini" /></a>';
									   $forum['writer_photo_thumb'] = $writer_photo_thumb ;

							        }
									 $username = '<a href="index.php?page=profile&amp;show=1&amp;id=' . $user_id . '">' . $username . '</a> ';
									 $forum['last_writer'] = $PowerBB->functions->rewriterule($username);
								  }
								  else
								  {
									 $forum['last_writer'] = $username;
							      }

							  }
							  else
							  {
								 $username = '<a href="index.php?page=profile&amp;show=1&amp;username=' . $username . '">' . $username . '</a> ';
								 $forum['last_writer'] = $PowerBB->functions->rewriterule($username);
							  }

							}
							else
							{
								$writer_photo_thumb = '<img src="' . $PowerBB->_CONF['template']['image_path'].'/'.$PowerBB->_CONF['info_row']['default_avatar'] . '" alt="photo" class="UserPhoto_mini" /></a>';
								 $forum['writer_photo_thumb'] = $writer_photo_thumb ;
							}
	                          //

						  // Get the moderators list as a _link_ and store it in $forum['moderators_list']
		                   if ($PowerBB->_CONF['info_row']['no_moderators'])
						   {
								$forum['is_moderators'] 		= 	0;
								$forum['moderators_list']		=	'';

								if (!empty($forum['moderators']))
								{
									$moderators = unserialize($forum['moderators']);

									if (is_array($moderators))
									{
		                               foreach($moderators as $moderator)
										{
											if (!$forum['is_moderators'])
											{
												$forum['is_moderators'] = 1;
											}
										               if ($PowerBB->_CONF['info_row']['rewriterule'] == '1')
														{
														$forum['moderators_list'] .= '<a href="u' . $moderator['member_id'] . '.html">' . $PowerBB->functions->GetUsernameStyle($moderator['username']) . '</a> , ';
														}
														else
														{
											            $forum['moderators_list'] .= '<a href="index.php?page=profile&amp;show=1&amp;id=' . $moderator['member_id'] . '">' . $PowerBB->functions->GetUsernameStyle($moderator['username']) .'</a> , ';
														}
										}
									}
								}
		                    }
							//////////


							// Get online forums
							if ($PowerBB->_CONF['info_row']['active_forum_online_number'])
							{
							$Forum_online_number = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['online'] . " WHERE section_id='" . $forum['id'] . "'"));
							$forum['forum_online'] = $Forum_online_number;
							}

							 $forum_title_color = "'".$forum['forum_title_color']."'";
							 $forum['title'] = "<font color=".$forum_title_color.">".$forum['title']."</font>";
							$PowerBB->_CONF['template']['foreach']['forums_list'][$forum['id'] . '_f'] = $forum;
							unset($groups);

						}// end view forums
		             } // end foreach ($forums)
			  } // end !empty($forums_cache)
		   } // end view section

				unset($SecArr);
				$SecArr = @mysql_free_result($SecArr);
		} // end foreach ($cats)


		//////////
	}


	/**
	 * Check if delicious cookie is here or another eat it mmmm :)
	 */
	function IsCookie($cookie_name)
 	{
 		global $PowerBB;
		// I hate SQL injections
		$PowerBB->_COOKIE[$cookie_name] = $PowerBB->functions->CleanVariable($PowerBB->_COOKIE[$cookie_name],'sql');
		// I hate XSS
		$PowerBB->_COOKIE[$cookie_name] = $PowerBB->functions->CleanVariable($PowerBB->_COOKIE[$cookie_name],'html');
 		return empty($PowerBB->_COOKIE[$cookie_name]) ? false : true;
 	}

 	/**
 	 * Clean the variable from any dirty :) , we should be thankful for abuamal
 	 *
 	 * By : abuamal
 	 */
	function CleanVariable($variable, $type)
	{
		global $PowerBB;

		return $PowerBB->sys_functions->CleanVariable($variable, $type);
	}

 	function AddressBar($title)
 	{
 		global $PowerBB;

 		$PowerBB->template->display('address_bar_part1');
 		echo $title;
 		$PowerBB->template->display('address_bar_part2');
 	}

 	/**
 	 * Show footer and stop the script , footer is like water in the life :)
 	 */
 	function stop($no_style = false)
 	{
 		global $PowerBB;

 		if (!$no_style)
 		{
 			$PowerBB->template->display('footer');
 		}

 		exit();
 	}

 	/**
 	 * go to $site , abuamal hate this function :D don't ask me why , ask him ;)
 	 */
	function redirect($site,$m=0)
 	{
     global $PowerBB;
  		echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"$m; URL=$site\">\n";
		$transition_click = $PowerBB->_CONF['template']['_CONF']['lang']['If_your_browser_does_not_support_automatic_transition_click_here'];
        $transition = ('<div class="Button_redirect"><a class="Button_secondary" href="'.$PowerBB->functions->rewriterule($site).'">'.$PowerBB->functions->rewriterule($transition_click).'</a></div>');
        echo $transition;
 	}

	function redirect2($site,$m=0)
 	{
     global $PowerBB;
  		echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"$m; URL=$site\">\n";
      $transition = ('<a href="'.$PowerBB->functions->rewriterule($site).'">'.$PowerBB->functions->rewriterule($transition_click).'</a>');
 	}


	/**
	* Halts execution and redirects to the specified URL invisibly
	*
	* @param	string	Destination URL
	*/
	function header_redirect($url, $redirectcode = 303)
 	{
	     global $PowerBB;
		$url = str_replace('&amp;', '&', $url); // prevent possible oddity
		if (@strpos($url, "\r\n") !== false)
		{
			trigger_error("Header may not contain more than a single header, new line detected.", E_USER_ERROR);
		}

		if ($redirectcode == 303 AND $PowerBB->_SERVER['SERVER_PROTOCOL'] == 'HTTP/1.0')
		{
			$redirectcode = 302;
		}
        $url = $PowerBB->functions->rewriterule($url);
		 @header("Location: $url", 0, $redirectcode);
	  	 exit;
 	}

	/**
	 * Show $msg in nice template
	 */
 	function msg($msg,$no_style = false)
    {
    	global $PowerBB;

    	if (defined('STOP_STYLE')
    		or $no_style)
 		{
    		 $PowerBB->template->assign('msg',$msg);
    		$PowerBB->template->display('show_msg');
    	}
    	else
    	{
    		echo '<font face="Tahoma" size="2"><div dir=' . $PowerBB->_CONF['info_row']['content_dir'] . ' align="center">' . $msg . '</div></font>';
    	}
 	}

	function install_msg($code)
	{
		$installation_state = $PowerBB->_CONF['template']['_CONF']['lang']['installation_state'];
	echo '<table border="0" cellspacing="1" width="50%" class="t_style_b" align="center">
		<tr>
			<td class="main1" colspan="2" height="23">
	'.$installation_state.'
			</td>
		</tr>
		<tr>
			<td class="row1" colspan="2" align="center">
			<p>
	';
	eval($code);

	echo '</p>
			</td>
		</tr>
	</table>
	<br />
	<br />';

	}

    function reputation_alert($msg)
    {
       global $PowerBB;
          if (!$no_header and $no_style)
          {
          $this->ShowHeader('');
          }
       echo "<script>alert('".$msg."');</script>";
       $this->stop(TRUE);
    }


 	 function stoperror($no_style = false)
 	{
 		global $PowerBB;

 		if (!$no_style)
 		{

 		}

 		exit();
 	}


 	function msgerror($msg,$no_style = false)
    {
    	global $PowerBB;

    	if (defined('IN_ADMIN')
    		or defined('STOP_STYLE')
    		or $no_style)
 		{
    		echo '<font face="Tahoma" size="2"><div dir=' . $PowerBB->_CONF['info_row']['content_dir'] . ' align="center">' . $msg . '</div></font>';

    	}

 	}

 		/**
	 * Show error massege and stop script
	 */
 	function errorstop($msgerror,$no_header = false,$no_style = false)
    {
    	global $PowerBB;

    	if (!$no_header and $no_style)
    	{
    		$this->ShowHeader('');
    	}

  		$this->msgerror($msgerror,$no_style);
  		$this->stoperror($no_style);
 	}

	/**
	 * Show error massege and stop script
	 */
 	function error($msg,$no_header = false,$no_style = false)
    {
    	global $PowerBB;

    	if (!$no_header and $no_style)
    	{
    		$this->ShowHeader('');
    	}

  		$this->msg($msg,$no_style);
  		$this->stop($no_style);
 	}

	/**
	 * Check if $email is true email or not
	 *
	 * This function by : Pal Coder from PowerBB 1.x
	 */
	function CheckEmail($email)
	{
	return preg_match('#^[a-z0-9.!\#$%&\'*+-/=?^_`{|}~]+@([0-9.]+|([^\s\'"<>@,;]+\.+[a-z]{2,6}))$#si', $email) ? true : false;
	}


 	/**
 	 * Get file extention
 	 *
 	 * @param :
 	 *				filename -> the name of file which we want know it's extension
 	 */

	function GetFileExtension($filename)
	{
				global $PowerBB;

              if ( stristr($filename,'.php') )
             {
              $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['Can_you_raise_file_extension']);
			}
			if ( stristr($filename,'.php3') )
             {
              $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['Can_you_raise_file_extension']);
			}
			if ( stristr($filename,'.phtml') )
             {
              $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['Can_you_raise_file_extension']);
			}
			if ( stristr($filename,'.pl') )
             {
              $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['Can_you_raise_file_extension']);
			}
			if ( stristr($filename,'.cgi') )
             {
              $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['Can_you_raise_file_extension']);
			}
			if ( stristr($filename,'.asp') )
             {
             $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['Can_you_raise_file_extension']);
			}
			if ( stristr($filename,'.3gp') )
             {
              $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['Can_you_raise_file_extension']);
			}
			if ( stristr($filename,'.exe') )
             {
              $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['Can_you_raise_file_extension']);
			}

	   $temparray = explode(".", $filename);
	   $extension = $temparray[count($temparray) - 1];
	   $extension = strtolower($extension);

	   return '.' . $extension;
	}

 	/**
 	 * Show the default footer of forum page
 	 */
 	function GetFooter()
 	{
 		// The instructions stored in footer module
 		// so include footer module to execute these inctructions
         require_once(DIR . 'modules/footer.module.php');

 		// Get the name of class
        $footer_name = FOOTER_NAME;

        // Make a new object
        $footer_name = new $footer_name;

        // Execute inctructions
        $footer_name->run();
 	}

 	/**
 	 * Show the default header of forum page
 	 */
 	function ShowHeader($title = null)
 	{
 		global $PowerBB;

		// visito today number  today_cookie
        $PowerBB->functions->visitor_today_number();

       $PowerBB->_GET['id']	= 	$PowerBB->functions->CleanVariable($PowerBB->_GET['id'],'intval');

 		// Check if title is empty so use the default name of forum
 		// which stored in info_row['title']
 		$title = (isset($title)) ? $title : $PowerBB->_CONF['info_row']['title'];
		$page = empty($PowerBB->_GET['page']) ? 'index' : $PowerBB->_GET['page'];
		$page_address 					= 	array();
		if ($page == 'index')
		{
		$page_address['index'] 		= 	$PowerBB->_CONF['info_row']['title'];
		$PowerBB->template->assign('description',$PowerBB->_CONF['info_row']['description']);
		$PowerBB->template->assign('keywords',$PowerBB->_CONF['info_row']['keywords']);
		$PowerBB->template->assign('index',1);
		}
		elseif ($PowerBB->_GET['page'] == 'forum')
		{
        $Forum 			= 	array();
		$Forum['where'] 	= 	array('id',$PowerBB->_GET['id']);
		$Forum_rwo = $PowerBB->core->GetInfo($Forum,'section');
		$page_address['forum'] 		= 	$Forum_rwo['title'] .' - '. $PowerBB->_CONF['info_row']['title'];
		 $PowerBB->template->assign('description',$Forum_rwo['title']);
		}
		elseif ($PowerBB->_GET['page'] == 'profile')
		{
	        $MemberArr 			= 	array();
			if (empty($PowerBB->_GET['id']))
			{
			$MemberArr['where'] 	= 	array('username',$PowerBB->_GET['username']);
			}
			else
			{
			$MemberArr['where'] 	= 	array('id',$PowerBB->_GET['id']);
			}
		   $MemInfo = $PowerBB->core->GetInfo($MemberArr,'member');

		$page_address['profile'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['View_Member_Profile'].' '. $MemInfo['username'] .' - '. $PowerBB->_CONF['info_row']['title'];
		}
		elseif ($PowerBB->_GET['page'] == 'post')
		{
		$ReplyArr = array();
		$ReplyArr['where'] = array('id',$PowerBB->_GET['id']);

		$ReplyInfo = $PowerBB->core->GetInfo($ReplyArr,'reply');

		$page_address['post'] 		= 	$PowerBB->Powerparse->censor_words($PowerBB->_CONF['template']['_CONF']['lang']['view_single_post'].': '. $ReplyInfo['title']);

		$TagArr 			= 	array();
		$TagArr['where'] 	= 	array('subject_id',$ReplyInfo['subject_id']);

		$PowerBB->_CONF['template']['while']['tags'] = $PowerBB->tag->GetSubjectList($TagArr);
		$num = '100';
		$ReplyInfo['text'] = $PowerBB->functions->words_count_replace_strip_tags_html2bb($ReplyInfo['text'],$num);

         $PowerBB->template->assign('keywords',$PowerBB->_CONF['template']['while']['tags']);
		 $PowerBB->template->assign('description',$ReplyInfo['text']);
		}
		elseif ($PowerBB->_GET['page'] == 'topic')
		{
		$SubjectArr = array();
		$SubjectArr['where'] = array('id',$PowerBB->_GET['id']);

		$SubjectInfo = $PowerBB->core->GetInfo($SubjectArr,'subject');

		$page_address['topic'] 		= 	$PowerBB->Powerparse->censor_words($SubjectInfo['prefix_subject'].' '.$SubjectInfo['title']);

		$TagArr 			= 	array();
		$TagArr['where'] 	= 	array('subject_id',$PowerBB->_GET['id']);

		$PowerBB->_CONF['template']['while']['tags'] = $PowerBB->tag->GetSubjectList($TagArr);
		$num = '100';

		$SubjectInfo['text'] = $PowerBB->functions->words_count_replace_strip_tags_html2bb($SubjectInfo['text'],$num);
         $PowerBB->template->assign('keywords',$PowerBB->_CONF['template']['while']['tags']);
        $PowerBB->template->assign('description',$SubjectInfo['text']);
		}
		elseif ($PowerBB->_GET['rules'] == '1')
		{
		$page_address['misc'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['rules'] .' - '. $PowerBB->_CONF['info_row']['title'];
		}
        elseif ($PowerBB->_GET['sendmessage'] == '1')
		{
		$page_address['send'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Contact_Manager'] .' - '. $PowerBB->_CONF['info_row']['title'];
		}
        elseif ($PowerBB->_GET['folder'] == 'sent')
		{
		$page_address['pm_list'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Outgoing_Messages'] .' - '. $PowerBB->_CONF['info_row']['title'];
		}
        elseif ($PowerBB->_GET['folder'] == 'inbox')
		{
		$page_address['pm_list'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Contained_Messages'] .' - '. $PowerBB->_CONF['info_row']['title'];
		}
        elseif ($PowerBB->_GET['info'] == '1')
		{
		$page_address['usercp'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Your_Personal_Information'] .' - '. $PowerBB->_CONF['info_row']['title'];
		}
		elseif ($PowerBB->_GET['page'] == 'pages')
		{
		$PageArr 			= 	array();
		$PageArr['where'] 	= 	array('id',$PowerBB->_GET['id']);

		$PowerBB->_CONF['template']['GetPage'] = $PowerBB->core->GetInfo($PageArr,'pages');

		$page_address['pages'] 		= 	$PowerBB->Powerparse->censor_words($PowerBB->_CONF['template']['GetPage']['title'] .' - '. $PowerBB->_CONF['info_row']['title']);
		}
		elseif ($PowerBB->_CONF['info_row']['board_close'] == '1')
    	{
		$title 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['board_close'];
 		}
		elseif ($PowerBB->_GET['page'] == 'management'
		AND $PowerBB->_GET['subject'] == '1'
		AND $PowerBB->_GET['operator'] == 'edit')
    	{
		$page_address['management'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['edit_subject'] .' - '. $PowerBB->_CONF['info_row']['title'];
 		}
		elseif ($PowerBB->_GET['page'] == 'management'
		AND $PowerBB->_GET['reply'] == '1'
		AND $PowerBB->_GET['operator'] == 'edit')
    	{
		$page_address['management'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['edit_reply'] .' - '. $PowerBB->_CONF['info_row']['title'];
 		}
		elseif ($PowerBB->_GET['operator'] == 'move')
    	{
		$page_address['management'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['mov_Subject'] .' - '. $PowerBB->_CONF['info_row']['title'];
 		}
		elseif ($PowerBB->_GET['operator'] == 'close')
    	{
		$page_address['management'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['locked_Topic'] .' - '. $PowerBB->_CONF['info_row']['title'];
 		}
		elseif ($PowerBB->_GET['operator'] == 'repeated')
    	{
		$page_address['management'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['repeated_Subject'] .' - '. $PowerBB->_CONF['info_row']['title'];
 		}
		elseif ($PowerBB->_GET['operator'] == 'tools_thread')
    	{
		$page_address['management'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Management_Subjects'] .' - '. $PowerBB->_CONF['info_row']['title'];
 		}
		elseif ($PowerBB->_GET['page'] == 'tags')
		{
		$TagInfoArr 			= 	array();
		$TagInfoArr['where'] 	= 	array('tag_id',$PowerBB->_GET['id']);
		$TagInfo = $PowerBB->tag_subject->GetSubjectInfo($TagInfoArr);

		$page_address['tags'] 			= 	$TagInfo['tag'] .' - '. $PowerBB->_CONF['info_row']['title'];
		}
		elseif ($PowerBB->_GET['page'] == 'portal')
		{
		$page_address['portal'] 		= 	$PowerBB->_CONF['info_row']['title_portal'];
		}
		$page_address['managementreply']= 	$PowerBB->_CONF['template']['_CONF']['lang']['Management_Subjects'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['static'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['statics'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['member_list'] 	= 	$PowerBB->_CONF['template']['_CONF']['lang']['memberlist'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['search'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Search_Engine'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['announcement'] 	= 	$PowerBB->_CONF['template']['_CONF']['lang']['announcement'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['team'] 			= 	$PowerBB->_CONF['template']['_CONF']['lang']['Leaders'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['login'] 		    = 	$PowerBB->_CONF['template']['_CONF']['lang']['Login_mem'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['logout'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Guidance_re'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['usercp'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['User_Control_Panel'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['pm'] 			= 	$PowerBB->_CONF['template']['_CONF']['lang']['Read_the_message'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['new_topic'] 	= 	$PowerBB->_CONF['template']['_CONF']['lang']['add_new_topic'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['new_reply'] 	= 	$PowerBB->_CONF['template']['_CONF']['lang']['add_new_reply'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['vote'] 			= 	$PowerBB->_CONF['template']['_CONF']['lang']['show_votes'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['online'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['online_naw'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['pm_setting'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Settings_Private_Messages'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['warn'] 		       = 	$PowerBB->_CONF['template']['_CONF']['lang']['send_warn'];
		$page_address['pm_setting'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Settings_Private_Messages'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['report'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Report_bad_post'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['register'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['register'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['latest_reply'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['latest_reply'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['latest'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['subject_today'];
		$page_address['special_subject'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Special_Subject'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['calendar'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Calendar'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['page'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Settings_Private_Messages'] .' - '. $PowerBB->_CONF['info_row']['title'];
		$page_address['sitemap'] 		= 	$PowerBB->_CONF['template']['_CONF']['lang']['Sitemap_title'] .' - '. $PowerBB->_CONF['info_row']['title'];
		if (array_key_exists($page,$page_address))
		{
			$title = $page_address[$page];
		}
         $PowerBB->template->assign('title',$title);
        // $PowerBB->template->assign('title',$this->GetForumAdress());

 		// Show header template

 		$PowerBB->template->display('headinclud');

 	}

 	/**
 	 * Get the forum's url adress
 	 */
 	function GetForumAdress()
 	{
 		global $PowerBB;

 		$domain_address 	= 	$PowerBB->_SERVER['HTTP_HOST'];
 		$filename 			= 	$PowerBB->_SERVER['REQUEST_URI'];
 		$filename 			= 	explode('/',$filename);

		$Duplication_index 			= 	"index.php/index.php?page";
		if (@strstr($filename,$Duplication_index))
		{
		$filename = str_replace('index.php/index.php?page','index.php?page',$filename);
		@header("Location:".$filename);
		exit;
		}

 		$last_part = '';
 		// The programme is under main folder (/var/www)
 		if (sizeof($filename) == 2)
 		{
 			// $last_part = '/';
 		}
 		// The programme is under something like this (/public_html/PowerBB)
 		elseif (sizeof($filename) == 3)
 		{
 			$last_part = '/' . $filename[1];
 		}
 		// The programme is under something like this (/public_html/PowerBB/PowerBB-Again)
 		elseif (sizeof($filename) == 4)
 		{
 			$last_part = '/' . $filename[1] . '/' . $filename[2];
 		}

 		$url = 'http://' . $domain_address . $last_part . '/';
        //$url = str_replace($PowerBB->admincpdir."/", '', $url);

 		return $url;
 	}

 	/**
 	 * Get a strong random code :)
 	 */
 	function RandomCode()
    {
  		$code = rand(1,500) . rand(1,1000) . microtime();
  		$code = @ceil($code);

  		$code = base64_encode($code);
  		$code = substr($code,0,15);

  		$code = str_replace('=',rand(1,100),$code);

  		return $code;
 	}

	/**
	 * Just send email for phpmail :)
	 */
 	function mail($to,$subject,$message,$sender)
    {
    	$headers  = "MIME-Version: 1.0\n";
    	$headers .= "Content-type: text/html; charset=utf-8\n";
    	$headers .= "From: <$sender>\n";
    	$headers .= "Reply-To: $sender\n";

        $send = @mail($to, $subject, $message, $headers);

        return ($send) ? true : false;
 	}

	/**
	 * Just send email for smtp :)
	 */
  function send_this_smtp($to, $fromname, $message, $subject, $from)
    {
        global $PowerBB;
		require_once(DIR . 'includes/class.phpmailer.php');
		require_once(DIR . 'includes/class.smtp.php');
		$host = $PowerBB->_CONF['info_row']['smtp_server'];
        $port = $PowerBB->_CONF['info_row']['smtp_port'];
		$mail             = new PHPMailer();
		$header  = "MIME-Version: 1.0\n";
		$header .= "Content-type: text/html; charset=utf-8\n";
		$header .= "From: <$from>\n";
		$header .= "Reply-To: $from\n";
	    // HTML body
	    $body  = "";
	    $body .= "";
	    $body .= $message;
	    // Plain text body (for mail clients that cannot read HTML)
	    $text_body  = "";
	    $text_body .= "";
	    $text_body .= $fromname;
		$mail->IsSMTP();
        $mail->SMTPAuth   = ($PowerBB->_CONF['info_row']['smtp_username'] && $PowerBB->_CONF['info_row']['smtp_password'] ? true : false);
		$mail->SMTPSecure = $PowerBB->_CONF['info_row']['smtp_secure'];

		$mail->Host = $PowerBB->_CONF['info_row']['smtp_server'];  // specify main and backup server
        $mail->Mailer   = "smtp";
		$mail->Port = $PowerBB->_CONF['info_row']['smtp_port'];
        $mail->CharSet = "UTF-8";
		$mail->Username = $PowerBB->_CONF['info_row']['smtp_username'];  // SMTP username
		$mail->Password = $PowerBB->_CONF['info_row']['smtp_password']; // SMTP password
		$mail->From = $from;
		$mail->FromName = $fromname;
		$mail->Subject = $subject;
		$mail->Body = $body;
		$mail->AltBody = $text_body;
		$mail->WordWrap   = 60; // set word wrap
		$mail->MsgHTML($body);
        $mail->AddReplyTo($to,$PowerBB->_CONF['info_row']['title']);
		$mail->AddAddress($to,$PowerBB->_CONF['info_row']['title']);
		$mail->IsHTML(true); // send as HTML
		if(!$mail->Send()) {
          $PowerBB->functions->error("Mailer Error: " . $mail->ErrorInfo);
      	 if ($PowerBB->_CONF['info_row']['ajax_register'])
      	 {
		  $PowerBB->functions->error("Mailer Error: " . $mail->ErrorInfo,$stop,$stop);
         }
		}

        $send = $mail->Send($to, $fromname, $message, $subject, $header);

        return ($send) ? true : false;
 	}



 	function words_count($string,$words_count)
 	{
 	 global $PowerBB;

		$string_arr = explode(" ", $string);

		for($i = sizeof($string_arr); $i >= $words_count; $i--)
		{
		    unset($string_arr[$i]);
		}

		$new_string = implode(" ",$string_arr);

		return ($new_string);
    }

 	function words_count_replace_strip_tags_html2bb($string,$words_count)
 	{
 	 global $PowerBB;
 		$string = $PowerBB->Powerparse->replace($string);
		$PowerBB->Powerparse->replace_smiles($string);
		$string = strip_tags($string);
		$string_arr = explode(" ", $string);
		for($i = sizeof($string_arr); $i >= $words_count; $i--)
		{
		    unset($string_arr[$i]);
		}

		$new_string = implode(" ",$string_arr);
        $string = $PowerBB->Powerparse->censor_words($string);
		$new_string = $PowerBB->Powerparse->html2bb($new_string);
		$new_string = @str_replace("\n", ' ', $new_string);
		$new_string = @str_replace("\r", '', $new_string);
		$new_string = @str_replace("\t", '', $new_string);
		$new_string = @str_replace("   ", " ", $new_string);
		$new_string = @str_replace("  ", " ", $new_string);
		$new_string = @htmlspecialchars($new_string);

		return ($new_string);
    }

 	function replace_strip($string)
 	{
 	 global $PowerBB;

		$string = $PowerBB->Powerparse->replace($string);
		$PowerBB->Powerparse->replace_smiles($string);
		//$string = strip_tags($string);
        $string = $PowerBB->Powerparse->censor_words($string);

		return ($string);
    }
 	/**
 	 * Check if $adress is true site adress or not
 	 */
 	function IsSite($adress)
 	{
 		return preg_match('~http:\/\/(.*?)~',$adress) ? true : false;
 	}

 	function GetURLExtension($path)
 	{
 		global $PowerBB;

 		$filename = basename($path);

		return $this->GetFileExtension($filename);
 	}

	function date($input)
	{
		global $PowerBB;
		return $PowerBB->sys_functions->date($input);
	}

	function time_ago($input)
	{
		global $PowerBB;
		return $PowerBB->sys_functions->time_ago($input);
	}

	function time($time)
	{
		global $PowerBB;

		return $PowerBB->sys_functions->time($time);
	}

	function GetUsernameStyleAndUserId($username)
	{
		global $PowerBB;

     if ($PowerBB->_CONF['info_row']['get_group_username_style'])
      {
			if (!empty($username))
			{
	   		// Get username style
			$MemberArr 			= 	array();
			$MemberArr['where'] 	= 	array('username',$username);

			$StyleMemberInfo = $PowerBB->core->GetInfo($MemberArr,'member');
	        $username = $StyleMemberInfo['username_style_cache'];
	        $user_id = $StyleMemberInfo['id'];
	        // get writer photo
	        /*
			if ($PowerBB->_CONF['info_row']['allow_avatar'])
			{

		        if (!$StyleMemberInfo['avater_path'])
		        {
	            $avater_path = $PowerBB->_CONF['template']['image_path'].'/'.$PowerBB->_CONF['info_row']['default_avatar'];
	            }
	            else
		        {
	            $avater_path = $StyleMemberInfo['avater_path'];
	            }
			   $writer_photo_thumb = '<a href="index.php?page=profile&amp;show=1&amp;id=' . $user_id . '"><img src="' . $avater_path . '" alt="photo" class="UserPhoto UserPhoto_mini"></a>';
	        }
	        */
			 $username = '<a href="index.php?page=profile&amp;show=1&amp;id=' . $user_id . '">' . $username . '</a> ';
			 return $writer_photo_thumb. $username = $PowerBB->functions->rewriterule($username);
		  }
		  else
		  {
			return $username;
	      }

	  }
	  else
	  {
		 $username = '<a href="index.php?page=profile&amp;show=1&amp;username=' . $username . '">' . $username . '</a> ';
		 return $username = $PowerBB->functions->rewriterule($username);
      }

	}

	function GetUsernameStyle($username)
	{
		global $PowerBB;
     if ($PowerBB->_CONF['info_row']['get_group_username_style'])
      {
   		// Get username style of last_writer
		$MemberArr 			= 	array();
		$MemberArr['where'] 	= 	array('username',$username);

		$StyleMemberInfo = $PowerBB->core->GetInfo($MemberArr,'member');
        $username = $StyleMemberInfo['username_style_cache'];

		return $username;
	  }
	  else
	  {
		 $username = '<a href="index.php?page=profile&amp;show=1&amp;username=' . $username . '">' . $username . '</a> ';
		 return $username = $PowerBB->functions->rewriterule($username);
      }
	}



	function GetwriterGroupStyle($Username,$Group)
	{
		global $PowerBB;
     if ($PowerBB->_CONF['info_row']['get_group_username_style'])
      {
		 if (!empty($Username))
		  {
	   		// Get username style of writer
			$MemberGroupArr 			= 	array();
			$MemberGroupArr['where'] 	= 	array('id',$Group);

			$GroupInfo = $PowerBB->core->GetInfo($MemberGroupArr,'group');

	         $style = $GroupInfo['username_style'];
			$username_style_cache = str_replace('[username]',$Username,$style);

			return $username_style_cache;
		  }
		  else
		  {
			return $Username;
	      }
	  }
	  else
	  {
        return $Username;
      }
	}

	function GetEditorTools()
	{
		global $PowerBB;

		if (!is_object($PowerBB->icon))
		{
			trigger_error('ERROR::ICON_OBJECT_DID_NOT_FOUND',E_USER_ERROR);
		}

		$SmlArr 					= 	array();
		$SmlArr['order'] 			=	array();
		$SmlArr['order']['field']	=	'id';
		$SmlArr['order']['type']	=	'ASC';
		$SmlArr['limit']			=	$PowerBB->_CONF['info_row']['smiles_nm'];
		$SmlArr['proc'] 			= 	array();
		$SmlArr['proc']['*'] 		= 	array('method'=>'clean','param'=>'html');

		$PowerBB->_CONF['template']['while']['SmileRows'] = $PowerBB->icon->GetSmileList($SmlArr);

		$IcnArr 					= 	array();
		$IcnArr['order'] 			=	array();
		$IcnArr['order']['field']	=	'id';
		$IcnArr['order']['type']	=	'DESC';
		$IcnArr['limit']			=	$PowerBB->_CONF['info_row']['icns_nm'];
		$IcnArr['proc'] 			= 	array();
		$IcnArr['proc']['*'] 		= 	array('method'=>'clean','param'=>'html');

		$PowerBB->_CONF['template']['while']['IconRows'] = $PowerBB->icon->GetIconList($IcnArr);
		$GetIconsNumber = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT smile_type FROM " . $PowerBB->table['smiles'] . " WHERE smile_type = '1'"));
		$PowerBB->template->assign('GetIconsNumber',$GetIconsNumber);


	}

	function ModeratorCheck($section_id,$username = null)
	{
		global $PowerBB;

		$Mod = false;

		if ($PowerBB->_CONF['member_permission'])
		{
			if ($PowerBB->_CONF['member_row']['usergroup'] == '1'
				or $PowerBB->_CONF['group_info']['vice'])
			{
				$Mod = true;
			}
			else
			{
				$ModArr = array();

				if ($username == null)
				{
					$ModArr['username'] = $PowerBB->_CONF['member_row']['username'];
				}
				else
				{
					$ModArr['username'] = $username;
				}

				$ModArr['section_id']	=	$section_id;

				$Mod = $PowerBB->moderator->IsModerator($ModArr);
			}

		}

		return $Mod;
	}


	/**
	 * dont Show error massege jast stop script
	 */
 	function error_stop($no_header = false,$no_style = false)
    {
    	global $PowerBB;

    	if (!$no_header and $no_style)
    	{
    		//$this->ShowHeader();
    	}

  		$this->stop($no_style);
 	}

	/**
	 * Show error massege and stop script
	 */
 	function stop_no_foot($no_style = false)
 	{
 		global $PowerBB;

 		if (!$no_style)
 		{
 			//$PowerBB->template->display('footer');
 		}

 		exit();
 	}

 	function error_no_foot($msg,$no_header = false,$no_style = false)
    {
    	global $PowerBB;

    	if (!$no_header and $no_style)
    	{
    		$this->ShowHeader();
    	}

  		$this->msg($msg,$no_style);
  		$this->stop_no_foot($no_style);
 	}

 	function GetTimezoneSet($timezone)
 	{
 		global $PowerBB;

		// Force PHP 5.3.0+ to take time zone information from OS
		if ($PowerBB->_CONF['info_row']['timeoffset'] != '')
		{
		// Get time zone
		@date_default_timezone_set($timezone);
		}

       return $timezone;
 	}

 	function GetDisplayForums()
 	{
 		global $PowerBB;
        $display_forums_nm = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['section'] . "  WHERE sec_section<>0"));
	   if ($display_forums_nm == '0')
	   {
		$update = $PowerBB->DB->sql_query("UPDATE " . $PowerBB->table['info'] . " SET value='0' WHERE var_name='last_subject_writer_not_in'");
       }
       else
	   {
         $DisplaSectionInfo = $PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['section'] . " WHERE sec_section<>0");
		  while ($display_forumsInfo = $PowerBB->DB->sql_fetch_array($DisplaSectionInfo))
	       {
		         $display_forums .= '0,'.$display_forumsInfo['id']. ',0';
				$update .= $PowerBB->DB->sql_query("UPDATE " . $PowerBB->table['info'] . " SET value='$display_forums' WHERE var_name='last_subject_writer_not_in'");
	      }
       }
		$PowerBB->_CONF['info_row']['last_subject_writer_not_in'] = str_ireplace('00,','',$PowerBB->_CONF['info_row']['last_subject_writer_not_in']);

 	}

	 function checkmobile($MOBILE_STYLEID)
	 {
	  global $PowerBB;

		if (@strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"WebTV")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"AvantGo")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Blazer")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"PalmOS")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"lynx")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Go.Web")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Elaine")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"ProxiNet")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"ChaiFarer")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Digital Paths")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"UP.Browser")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Mazingo")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"iPhone")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"iPod")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Mobile")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"T68")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Syncalot")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Danger")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Symbian")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Symbian OS")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"SymbianOS")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Maemo")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Nokia")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Xiino")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"AU-MIC")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"EPOC")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Wireless")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Handheld")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Smartphone")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"SAMSUNG")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"J2ME")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"MIDP")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"MIDP-2.0")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"320x240")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"240x320")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Blackberry8700")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Opera Mini")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"NetFront")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Android")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"webOS")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"BlackBerry")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"LG-")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"OperaMobi")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"IEMobile")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Jasmine")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Fennec")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Minimo")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"MOT-")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Polaris")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"Mobile")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"iPad")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"nokia")
		or @strstr($PowerBB->_SERVER['HTTP_USER_AGENT'],"mobile"))
		{
		$PowerBB->functions->change_style($MOBILE_STYLEID);
		}

	    $agent = $PowerBB->_SERVER['HTTP_USER_AGENT'];
	    $list_agent = explode(",",$PowerBB->_CONF['info_row']['search_engine_spiders']);
		for ($i=0;$i<count($list_agent);$i++)
		{
			if (@strstr($agent,$list_agent[$i]))
			{
               $PowerBB->functions->change_style($MOBILE_STYLEID);
			}
		}

	  }

	function is_bot()
	{
 		global $PowerBB;
	    $agent = $PowerBB->_SERVER['HTTP_USER_AGENT'];
	    $list_agent = explode(",",$PowerBB->_CONF['info_row']['search_engine_spiders']);
		for ($i=0;$i<count($list_agent);$i++)
		{
			if (@strstr($agent,$list_agent[$i]))
			{
			  return 1;
			}
		}
		return 0;
	}

	function bot_name()
	{
 		global $PowerBB;
	    $agent = $PowerBB->_SERVER['HTTP_USER_AGENT'];
	    $list_agent = explode(",",$PowerBB->_CONF['info_row']['search_engine_spiders']);
	 for ($i=0;$i<count($list_agent);$i++)
	 {
	   if (@strstr($agent,$list_agent[$i]))
	   {
	   	 return $list_agent[$i];
	   }

	 }

	   return;
    }


    function change_style($Style)
    {
        global $PowerBB;

			$StyleArr                =   array();
			$StyleArr['field']      =   array();
			$StyleArr['field']['style'] = $Style;
			if ($PowerBB->_CONF['member_permission'])
			{
			   $StyleArr['where'] = array('id',$PowerBB->_CONF['member_row']['id']);

			   $change = $PowerBB->member->UpdateMember($StyleArr);
				if (!$PowerBB->_GET['login'] AND !$PowerBB->_GET['page'] == "logout")
				{
				@ob_start();
				@setcookie("PowerBB_style", $Style, time()+3600);
				@ob_end_flush();
				}
			}
			else
			{
				if (!$PowerBB->_GET['login'] AND !$PowerBB->_GET['page'] == "logout")
				{
				@ob_start();
				@setcookie("PowerBB_style", $Style, time()+3600);
				@ob_end_flush();
				}
			}

       return;
    }

 	/**
 	 *Update Section Cache ;)
 	 */
	function UpdateSectionCache($SectionCache)
 	{
     global $PowerBB;

		// The number of section's subjects number
		$reply_num = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['reply'] . " WHERE section = '$SectionCache' "));

		$UpdateArr 					= 	array();
		$UpdateArr['field']			=	array();
		$UpdateArr['field']['reply_num'] 	= 	$reply_num;
		$UpdateArr['where']					= 	array('id',$SectionCache);

		$UpdateReplyNumber = $PowerBB->core->Update($UpdateArr,'section');


		$PowerBB->cache->UpdateReplyNumber(array('reply_num'	=>	$reply_num));


		$subject_nm = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['subject'] . " WHERE section = '$SectionCache' "));

		// The number of section's subjects number
		$UpdateArr 					= 	array();
		$UpdateArr['field']			=	array();

		$UpdateArr['field']['subject_num'] 	= 	$subject_nm;
		$UpdateArr['where']					= 	array('id',$SectionCache);

		$UpdateSubjectNumber = $PowerBB->core->Update($UpdateArr,'section');


		$PowerBB->cache->UpdateSubjectNumber(array('subject_num'	=>	$subject_nm));

		$GetLastqueryReplyForm = $PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['subject'] . " WHERE section = '$SectionCache' AND delete_topic<>1 AND review_subject<>1 ORDER by write_time DESC");
		$GetLastReplyForm = $PowerBB->DB->sql_fetch_array($GetLastqueryReplyForm);
         if ($GetLastReplyForm['last_replier'] !='')
         {
         	$last_writer = $GetLastReplyForm['last_replier'];
         }
		else
		{
         	$last_writer = $GetLastReplyForm['writer'];
        }
		if (!$GetLastReplyForm)
		{
		// Update Last subject's information in Section Form
		$UpdateLastFormSecArr = array();
		$UpdateLastFormSecArr['field']			=	array();

		$UpdateLastFormSecArr['field']['last_writer'] 		= 	'';
		$UpdateLastFormSecArr['field']['last_subject'] 		= 	'';
		$UpdateLastFormSecArr['field']['last_subjectid'] 	= 	'';
		$UpdateLastFormSecArr['field']['last_date'] 	= 	'';
		$UpdateLastFormSecArr['field']['last_time'] 	= 	'';
		$UpdateLastFormSecArr['field']['icon'] 		    = 	'';
		$UpdateLastFormSecArr['field']['last_reply'] 	= 	0;
		$UpdateLastFormSecArr['field']['last_berpage_nm']  = 	0;

		$UpdateLastFormSecArr['where'] 		        = 	array('id',$SectionCache);

		// Update Last Form Sec subject's information
		$UpdateLastFormSec = $PowerBB->core->Update($UpdateLastFormSecArr,'section');
		}
		else
		{

		$review_replyNumArr = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['reply'] . " WHERE section='$SectionCache' and review_reply=1 "));
		$review_subjectNumArr = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['subject'] . " WHERE section='$SectionCache' and review_subject=1 "));

		// Update Last subject's information in Section Form
		$UpdateLastFormSecArr = array();
		$UpdateLastFormSecArr['field']			=	array();

		$UpdateLastFormSecArr['field']['last_writer'] 		= 	$last_writer;
		$UpdateLastFormSecArr['field']['last_subject'] 		= 	$GetLastReplyForm['title'];
		$UpdateLastFormSecArr['field']['last_subjectid'] 	= 	$GetLastReplyForm['id'];
		$UpdateLastFormSecArr['field']['last_date'] 	= 	$GetLastReplyForm['write_time'];
		$UpdateLastFormSecArr['field']['last_time'] 	= 	$GetLastReplyForm['write_time'];
		$UpdateLastFormSecArr['field']['icon'] 		    = 	$GetLastReplyForm['icon'];
		$UpdateLastFormSecArr['field']['last_reply'] 	= 	0;
		$UpdateLastFormSecArr['field']['last_berpage_nm']  = 	0;
		$UpdateLastFormSecArr['field']['replys_review_num']  = 	$review_replyNumArr;
		$UpdateLastFormSecArr['field']['subjects_review_num']  = 	$review_subjectNumArr;

		$UpdateLastFormSecArr['where'] 		        = 	array('id',$SectionCache);

		// Update Last Form Sec subject's information
		$UpdateLastFormSec = $PowerBB->core->Update($UpdateLastFormSecArr,'section');
	   }
		// Get Section Info
		$SecArr 			= 	array();
		$SecArr['where'] 	= 	array('id',$SectionCache);

		$this->SectionInfo = $PowerBB->core->GetInfo($SecArr,'section');

		// Update section's cache
		$UpdateArr 				= 	array();
		$UpdateArr['parent'] 	= 	$this->SectionInfo['parent'];

		$update_cache = $PowerBB->section->UpdateSectionsCache($UpdateArr);


		unset($UpdateArr);



       return;

 	}

	function form_simple_input($name, $value="", $size, $color)
	{
		return "<input type='text' name='$name' value='$value' size='$size' class='$color' dir='ltr' style='float: left;'>";
	}

	function start_form($hiddens="", $name='theAdminForm', $js="", $id="")
	{
     global $PowerBB;

		if ( ! $id )
		{
			$id = $name;
		}

		$form = "<form action=".$this->GetForumAdress()." method='post' name='$name' $js id='$id'>";

		if (is_array($hiddens))
		{
			foreach ($hiddens as $v)
			{
				$form .= "\n<input type='hidden' name='{$v[0]}' value='{$v[1]}' />";
			}
		}

		//-----------------------------------------
		// Add in auth key
		//-----------------------------------------

		$form .= "\n<input type='hidden' name='_admin_auth_key' value='".$PowerBB->_POST['_admin_auth_key']."' />";

		return $form;
	}

	function _AllCacheStart()
	{
		global $PowerBB;

		$SecArr 					= 	array();
		$SecArr['get_from']			=	'db';
		$SecArr['proc'] 			= 	array();
		$SecArr['proc']['*'] 		= 	array('method'=>'clean','param'=>'html');
		$SecArr['order']			=	array();
		$SecArr['order']['field']	=	'sort';
		$SecArr['order']['type']	=	'ASC';

		$SecArr['where']				=	array();
		$SecArr['where'][0]				=	array();
		$SecArr['where'][0]['name']		=	'parent';
		$SecArr['where'][0]['oper']		=	'<>';
		$SecArr['where'][0]['value']	=	'0';

		$SecList = $PowerBB->core->GetList($SecArr,'section');

		$x = 0;
		$y = sizeof($SecList);
		$s = array();

		while ($x < $y)
		{
			$name = 'order-' . $SecList[$x]['id'];

			if ($SecList[$x]['order'] != $PowerBB->_POST[$name])
			{
				$UpdateArr 						= 	array();

				$UpdateArr['field']		 		= 	array();
				$UpdateArr['field']['sort'] 	= 	$PowerBB->_POST[$name];

				$UpdateArr['where'] 			=	array('id',$SecList[$x]['id']);

				$update = $PowerBB->core->Update($UpdateArr,'section');

				if ($update)
				{
					$cache = $PowerBB->section->UpdateSectionsCache(array('parent'=>$SecList[$x]['parent']));
					$cache = $PowerBB->section->UpdateSectionsCache(array('parent'=>$SecList[$x]['id']));


                         $UpdateSectionCache6 = $PowerBB->functions->UpdateSectionCache($SecList[$x]['id']);


				}

				$s[$SecList[$x]['id']] = ($update) ? 'true' : 'false';
			}

			$x += 1;

			    $section = $SecList[$x]['id'];
			    $subject_nm = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT  *   FROM " . $PowerBB->table['subject'] . " WHERE section = '$section' "));

	            // The number of section's subjects number
	     		$UpdateArr 					= 	array();
	     		$UpdateArr['field']			=	array();

	     		$UpdateArr['field']['subject_num'] 	= 	$subject_nm;
	     		$UpdateArr['where']					= 	array('id',$section);

	     		$UpdateSubjectNumber = $PowerBB->core->Update($UpdateArr,'section');

	           // $PowerBB->cache->UpdateSubjectNumber(array('subject_num'	=>	$subject_nm));

	                 		// The number of section's subjects number
	            $section = $SecList[$x]['id'];
			    $reply_num = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT  *   FROM " . $PowerBB->table['reply'] . " WHERE section = '$section' "));

	     		$UpdateArr 					= 	array();
	     		$UpdateArr['field']			=	array();

	     		$UpdateArr['field']['reply_num'] 	= 	$reply_num;
	     		$UpdateArr['where']					= 	array('id',$section);

	     		$UpdateReplyNumber = $PowerBB->core->Update($UpdateArr,'section');
	     		//$PowerBB->cache->UpdateReplyNumber(array('reply_num'	=>	$reply_num));

                // Get Section Info
				$SecArr 			= 	array();
				$SecArr['where'] 	= 	array('id',$section);

				$this->SectionInfo = $PowerBB->core->GetInfo($SecArr,'section');

     		// Update section's cache
     		$UpdateArr 				= 	array();
     		$UpdateArr['parent'] 	= 	$this->SectionInfo['parent'];

     		$update_cache = $PowerBB->section->UpdateSectionsCache($UpdateArr);

     		unset($UpdateArr);

					//////////

					$CacheArr 			= 	array();
					$CacheArr['where'] 	= 	array('section_id',$SecList[$x]['id']);
					$cache = $PowerBB->moderator->CreateModeratorsCache($CacheArr);

					$SecArr 				= 	array();
					$SecArr['field']		=	array();
					$SecArr['field']['moderators'] 	= 	$cache;
					$SecArr['where'] 			=	array('id',$SecList[$x]['id']);
					$update = $PowerBB->core->Update($SecArr,'section');

		}



	}

	function PermissionsSectionGroup($Section,$Group,$Permission)
	  {
		global $PowerBB;

		$SecGroupArr 						= 	array();
		$SecGroupArr['where'] 				= 	array();
		$SecGroupArr['where'][0]			=	array();
		$SecGroupArr['where'][0]['name'] 	= 	'section_id';
		$SecGroupArr['where'][0]['value'] 	= 	$Section;
		$SecGroupArr['where'][1]			=	array();
		$SecGroupArr['where'][1]['con']		=	'AND';
		$SecGroupArr['where'][1]['name']	=	'group_id';
		$SecGroupArr['where'][1]['value']	=	$Group;

		// Finally get the permissions of group
		$this->SectionGroup = $PowerBB->core->GetInfo($SecGroupArr,'sectiongroup');

		return $this->SectionGroup[$Permission];
		unset($SecGroupArr);
		@mysql_free_result($SecGroupArr);
	 }

	function _MeterGroupsStart()
	  {
		global $PowerBB;

        $query = $PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['section'] . " ");

        while ($r = $PowerBB->DB->sql_fetch_array($query))
	    {
			$CacheArr 			= 	array();
			$CacheArr['id'] 	= 	$r['id'];

			$cache = $PowerBB->group->UpdateSectionGroupCache($CacheArr);
		 }

	 }

	    /**
	 * Get the Jump Forums List
	 */
	function JumpForumsList()
    {
		global $PowerBB;

		$SecArr 						= 	array();
		$SecArr['get_from']				=	'db';

		$SecArr['proc'] 				= 	array();
		$SecArr['proc']['*'] 			= 	array('method'=>'clean','param'=>'html');

		$SecArr['order']				=	array();
		$SecArr['order']['field']		=	'sort';
		$SecArr['order']['type']		=	'ASC';

		$SecArr['where']				=	array();
		$SecArr['where'][0]['name']		= 	'parent';
		$SecArr['where'][0]['oper']		= 	'=';
		$SecArr['where'][0]['value']	= 	'0';

		// Get main sections
		$catys = $PowerBB->core->GetList($SecArr,'section');

 		////////////

		// Loop to read the information of main sections
		foreach ($catys as $caty)
		{
			@include("cache/sectiongroup_cache".$caty['id'].".php");
	       // Get the groups information to know view this section or not
	      $sectiongroup = unserialize(base64_decode($sectiongroup_cache['sectiongroup_cache']));
		  if ($sectiongroup[$PowerBB->_CONF['group_info']['id']]['view_section'])
	      {
             // foreach main sections
			$PowerBB->_CONF['template']['foreach']['forumsy_list'][$caty['id'] . '_m'] = $caty;

			unset($sectiongroup);

			@include("cache/forums_cache_".$caty['id'].".php");
			if (!empty($forums_cache['forums_cache']))
			{
                $forumsy = unserialize(base64_decode($forums_cache['forums_cache']));

					foreach ($forumsy as $forumy)
					{
						//////////////////////////
					     @include("cache/sectiongroup_cache".$forumy['id'].".php");
						$groups = unserialize(base64_decode($sectiongroup_cache['sectiongroup_cache']));
						if ($groups[$PowerBB->_CONF['group_info']['id']]['view_section'])
						{
							$forumy['is_sub'] 	= 	0;
							$forumy['sub']		=	'';
							$file_forums_cache =	"cache/forums_cache_".$forumy['id'].".php";
                               if (file_exists($file_forums_cache))
                               {
                                 @include("cache/forums_cache_".$forumy['id'].".php");
                               }
                               if (!empty($forums_cache['forums_cache']))
	                           {
									$subs = unserialize(base64_decode($forums_cache['forums_cache']));
	                               foreach ($subs as $sub)
									{
									   if ($forumy['id'] == $sub['parent'])
	                                    {

										 $file_sectiongroup = "cache/sectiongroup_cache".$sub['id'].".php";
			                               if (file_exists($file_sectiongroup))
			                               {
								            @include("cache/sectiongroup_cache".$sub['id'].".php");
			                               }
									        $groups = unserialize(base64_decode($sectiongroup_cache['sectiongroup_cache']));

												if (!$forumy['is_sub'])
												{
													$forumy['is_sub'] = 1;
												}
											  if ($groups[$PowerBB->_CONF['group_info']['id']]['view_section'])
											   {
                                                  if ($PowerBB->_GET['page'] == 'forum' && $PowerBB->_GET['show'] == 1 && $PowerBB->_GET['id'] == $sub['id'])
											   	  {
												   $selected = ' selected="selected"';
											      }
											      else
											   	  {
												   $selected = "";
											      }
											      	$forum_url = "index.php?page=forum&amp;show=1&amp;id=";
												    $forumy['sub'] .= ('<option ' .$selected . ' value="'.$PowerBB->functions->rewriterule($forum_url).$sub['id'] . '">--- '  . $sub['title'] . '</option>');

										        }
										  }

					                         ///////////////
									   if ($sub['id'] == $sub['parent'])
	                                    {
										$forumy['is_sub_sub'] 	= 	0;
										$forumy['sub_sub']		=	'';
										  $file_forums_cache =	"cache/forums_cache_".$sub['id'].".php";
			                               if (file_exists($file_forums_cache))
			                               {
			                                 @include("cache/forums_cache_".$sub['id'].".php");
			                               }
		                                   if (!empty($forums_cache['forums_cache']))
				                           {

												$subs_sub = unserialize(base64_decode($forums_cache['forums_cache']));
				                               foreach ($subs_sub as $sub_sub)
												{
												   if ($sub['id'] != $sub_sub['parent'])
				                                    {
														  $file_sectiongroup = "cache/sectiongroup_cache".$sub_sub['id'].".php";
							                               if (file_exists($file_sectiongroup))
							                               {
												            @include("cache/sectiongroup_cache".$sub_sub['id'].".php");
							                               }
												        $groups = unserialize(base64_decode($sectiongroup_cache['sectiongroup_cache']));
															if (!$forumy['is_sub_sub'])
															{
																$forumy['is_sub_sub'] = 1;
															}

														  if ($groups[$PowerBB->_CONF['group_info']['id']]['view_section'])
														   {
			                                                  if ($PowerBB->_GET['page'] == 'forum' && $PowerBB->_GET['show'] == 1 && $PowerBB->_GET['id'] == $sub_sub['id'])
														   	  {
															   $selected = ' selected="selected"';
														      }
														      else
														   	  {
															   $selected = "";
														      }
											               	$forum_url = "index.php?page=forum&amp;show=1&amp;id=";
															 $forumy['sub_sub'] .= ('<option ' .$selected . ' value="'.$PowerBB->functions->rewriterule($forum_url).$sub_sub['id'] . '">---- '  . $sub_sub['title'] . '</option>');
													        }
													  }
												 }

										   }

										 }
									 }
								}



							$PowerBB->_CONF['template']['foreach']['forumsy_list'][$forumy['id'] . '_f'] = $forumy;
							unset($groups);

						}// end view forums
		             } // end foreach ($forums)
			  } // end !empty($forums_cache)
		   } // end view section

				unset($SecArr);
				$SecArr = @mysql_free_result($SecArr);
		} // end foreach ($cats)

   }

	function range_key($max = 9)
	{
		global $PowerBB;
        $keytmp = rand(0, $max);
	  return $keytmp ;
	}

//	****** Conversion and shorten links ******
//	This setting allows you to change the links
 	function rewriterule($type)
	{
		global $PowerBB;
     if ($PowerBB->_CONF['info_row']['rewriterule'])
 	  {

   		$type = str_replace("index.php?page=forum&show=1&id=","f",$type);
   		$type = str_replace("index.php?page=forum&amp;show=1&amp;id=","f",$type);

   		$type = str_replace("index.php?page=forum&show=1&id=","f",$type);
   		$type = str_replace("index.php?page=forum&amp;show=1&amp;id=","f",$type);

   		$type = str_replace("index.php?page=topic&show=1&id=","t",$type);
   		$type = str_replace("index.php?page=topic&amp;show=1&amp;id=","t",$type);

   		$type = str_replace("index.php?page=profile&show=1&id=","u",$type);
   		$type = str_replace("index.php?page=profile&amp;show=1&amp;id=","u",$type);
   		$type = str_replace("index.php?page=profile&show=1&username=","name-",$type);
   		$type = str_replace("index.php?page=profile&amp;show=1&amp;username=","name-",$type);


   		$type = str_replace("index.php?page=print&show=1&id=","p",$type);
   		$type = str_replace("index.php?page=print&amp;show=1&amp;id=","p",$type);

   		$type = str_replace("index.php?page=archive","archive.html",$type);
   		//$type = str_replace("index.php?page=portal&","portal",$type);
   		$type = str_replace("index.php?page=portal","portal.html",$type);

   		$type = str_replace("index.php?page=forum_archive&show=1&id=","Af",$type);
   		$type = str_replace("index.php?page=forum_archive&amp;show=1&amp;id=","Af",$type);

   		$type = str_replace("index.php?page=topic_archive&show=1&id=","At",$type);
   		$type = str_replace("index.php?page=topic_archive&amp;show=1&amp;id=","At",$type);

   		//$type = str_replace("index.php?page=search&index=1","search.html",$type);
   		//$type = str_replace("index.php?page=search&amp;index=1","search.html",$type);

   		$type = str_replace("index.php?page=sitemap&subject=1","sitemap.xml",$type);
   		$type = str_replace("index.php?page=sitemap&amp;subject=1","sitemap.xml",$type);

   		$type = str_replace("index.php?page=sitemap&sitemaps=1","sitemap.htm",$type);
   		$type = str_replace("index.php?page=sitemap&amp;sitemaps=1","sitemap.htm",$type);

   		$type = str_replace("index.php?page=team&show=1","team.html",$type);
   		$type = str_replace("index.php?page=team&amp;show=1","team.html",$type);

   		$type = str_replace("index.php?page=misc&rules=1&show=1","rules.html",$type);
   		$type = str_replace("index.php?page=misc&amp;rules=1&amp;show=1","rules.html",$type);

   		$type = str_replace("index.php?page=calendar&show=1","calendar.html",$type);
   		$type = str_replace("index.php?page=calendar&amp;show=1","calendar.html",$type);

   		$type = str_replace("index.php?page=special_subject&index=1","special_subject.html",$type);
   		$type = str_replace("index.php?page=special_subject&amp;index=1","special_subject.html",$type);

   		$type = str_replace("index.php?page=member_list&amp;index=1&amp;show=1","member",$type);
   		$type = str_replace("index.php?page=member_list&amp;index=1&amp;order=1&amp;order_type=DESC","mem_order_posts",$type);
   		$type = str_replace("index.php?page=member_list&amp;index=1&amp;order=3&amp;order_type=DESC","mem_order_visit",$type);
   		$type = str_replace("index.php?page=member_list&amp;index=1&amp;order=2&amp;order_type=DESC","mem_order_reg",$type);
   		$type = str_replace("index.php?page=member_list&amp;index=1&amp;sort=username&amp;letr=","mem_order_letters",$type);

		$type = str_replace("index.php?page=member_list&index=1&order=1&order_type=DESC","mem_order_posts",$type);
		$type = str_replace("index.php?page=member_list&index=1&order=3&order_type=DESC","mem_order_visit",$type);
		$type = str_replace("index.php?page=member_list&index=1&order=2&order_type=DESC","mem_order_reg",$type);
		$type = str_replace("index.php?page=member_list&index=1&sort=username&letr=","mem_order_letters",$type);
   		$type = str_replace("index.php?page=member_list&index=1&show=1","member.html",$type);

   		$type = str_replace("index.php?page=static&index=1","static.html",$type);
   		$type = str_replace("index.php?page=static&amp;index=1","static.html",$type);

   		$type = str_replace("index.php?page=latest&today=1","today_subjects",$type);
   		$type = str_replace("index.php?page=latest&amp;today=1","today_subjects",$type);
      }

	   return $type;
	}

function xml_array($contents, $get_attributes=1, $priority = 'tag')
 {
	     global $PowerBB;

    if(!$contents) return array();

    if(!function_exists('xml_parser_create')) {
        //print "'xml_parser_create()' function not found!";
        return array();
    }

    //Get the XML parser of PHP - PHP must have this module for the parser to work
    $parser = xml_parser_create('');
    xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8"); # http://minutillo.com/steve/weblog/2004/6/17/php-xml-and-character-encodings-a-tale-of-sadness-rage-and-data-loss
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
    xml_parse_into_struct($parser, trim($contents), $xml_values);
    xml_parser_free($parser);

    if(!$xml_values) return;//Hmm...

    //Initializations
    $xml_array = array();
    $parents = array();
    $opened_tags = array();
    $arr = array();

    $current = &$xml_array; //Refference

    //Go through the tags.
    $repeated_tag_index = array();//Multiple tags with same name will be turned into an array
    foreach($xml_values as $data) {
        unset($attributes,$value);//Remove existing values, or there will be trouble

        //This command will extract these variables into the foreach scope
        // tag(string), type(string), level(int), attributes(array).
        extract($data);//We could use the array by itself, but this cooler.

        $result = array();
        $attributes_data = array();

        if(isset($value)) {
            if($priority == 'tag') $result = $value;
            else $result['value'] = $value; //Put the value in a assoc array if we are in the 'Attribute' mode
        }

        //Set the attributes too.
        if(isset($attributes) and $get_attributes) {
            foreach($attributes as $attr => $val) {
                if($priority == 'tag') $attributes_data[$attr] = $val;
                else $result['attr'][$attr] = $val; //Set all the attributes in a array called 'attr'
            }
        }

        //See tag status and do the needed.
        if($type == "open") {//The starting of the tag '<tag>'
            $parent[$level-1] = &$current;
            if(!is_array($current) or (!in_array($tag, array_keys($current)))) { //Insert New tag
                $current[$tag] = $result;
                if($attributes_data) $current[$tag. '_attr'] = $attributes_data;
                $repeated_tag_index[$tag.'_'.$level] = 1;

                $current = &$current[$tag];

            } else { //There was another element with the same tag name

                if(isset($current[$tag][0])) {//If there is a 0th element it is already an array
                    $current[$tag][$repeated_tag_index[$tag.'_'.$level]] = $result;
                    $repeated_tag_index[$tag.'_'.$level]++;
                } else {//This section will make the value an array if multiple tags with the same name appear together
                    $current[$tag] = array($current[$tag],$result);//This will combine the existing item and the new item together to make an array
                    $repeated_tag_index[$tag.'_'.$level] = 2;

                    if(isset($current[$tag.'_attr'])) { //The attribute of the last(0th) tag must be moved as well
                        $current[$tag]['0_attr'] = $current[$tag.'_attr'];
                        unset($current[$tag.'_attr']);
                    }

                }
                $last_item_index = $repeated_tag_index[$tag.'_'.$level]-1;
                $current = &$current[$tag][$last_item_index];
            }

        } elseif($type == "complete") { //Tags that ends in 1 line '<tag />'
            //See if the key is already taken.
            if(!isset($current[$tag])) { //New Key
                $current[$tag] = $result;
                $repeated_tag_index[$tag.'_'.$level] = 1;
                if($priority == 'tag' and $attributes_data) $current[$tag. '_attr'] = $attributes_data;

            } else { //If taken, put all things inside a list(array)
                if(isset($current[$tag][0]) and is_array($current[$tag])) {//If it is already an array...

                    // ...push the new element into that array.
                    $current[$tag][$repeated_tag_index[$tag.'_'.$level]] = $result;

                    if($priority == 'tag' and $get_attributes and $attributes_data) {
                        $current[$tag][$repeated_tag_index[$tag.'_'.$level] . '_attr'] = $attributes_data;
                    }
                    $repeated_tag_index[$tag.'_'.$level]++;

                } else { //If it is not an array...
                    $current[$tag] = array($current[$tag],$result); //...Make it an array using using the existing value and the new value
                    $repeated_tag_index[$tag.'_'.$level] = 1;
                    if($priority == 'tag' and $get_attributes) {
                        if(isset($current[$tag.'_attr'])) { //The attribute of the last(0th) tag must be moved as well

                            $current[$tag]['0_attr'] = $current[$tag.'_attr'];
                            unset($current[$tag.'_attr']);
                        }

                        if($attributes_data) {
                            $current[$tag][$repeated_tag_index[$tag.'_'.$level] . '_attr'] = $attributes_data;
                        }
                    }
                    $repeated_tag_index[$tag.'_'.$level]++; //0 and 1 index is already taken
                }
            }

        } elseif($type == 'close') { //End of tag '</tag>'
            $current = &$parent[$level-1];
        }
    }

    return($xml_array);
 }

 function with_comma($int)
 {
	if( is_numeric($int) ){
	$int=(strrev($int));
	preg_match_all("#[0-9]{1,3}#",$int,$m);
	return strrev(implode(',',$m[0]));
	}else{
	return 0;
	}
  }


/**
 * Gzip encodes text to a specified level
 *
 * @param string The string to encode
 * @param int The level (1-9) to encode at
 * @return string The encoded string
 */
function gzip_encode($contents, $level=1)
{
	if(function_exists("gzcompress") && function_exists("crc32") && !headers_sent() && !(ini_get('output_buffering') && $this->my_strpos(' '.ini_get('output_handler'), 'ob_gzhandler')))
	{
		$httpaccept_encoding = '';

		if(isset($_SERVER['HTTP_ACCEPT_ENCODING']))
		{
			$httpaccept_encoding = $_SERVER['HTTP_ACCEPT_ENCODING'];
		}

		if($this->my_strpos(" ".$httpaccept_encoding, "x-gzip"))
		{
			$encoding = "x-gzip";
		}

		if($this->my_strpos(" ".$httpaccept_encoding, "gzip"))
		{
			$encoding = "gzip";
		}

		if(isset($encoding))
		{
			@header("Content-Encoding: $encoding");

			if(function_exists("gzencode"))
			{
				$contents = gzencode($contents, $level);
			}
			else
			{
				$size = strlen($contents);
				$crc = crc32($contents);
				$gzdata = "\x1f\x8b\x08\x00\x00\x00\x00\x00\x00\xff";
				$gzdata .= $this->my_substr(gzcompress($contents, $level), 2, -4);
				$gzdata .= pack("V", $crc);
				$gzdata .= pack("V", $size);
				$contents = $gzdata;
			}
		}
	}

	return $contents;
}

/**
 * Cuts a string at a specified point, mb strings accounted for
 *
 * @param string The string to cut.
 * @param int Where to cut
 * @param int (optional) How much to cut
 * @param bool (optional) Properly handle HTML entities?
 * @return int The cut part of the string.
 */
 function my_substr($string, $start, $length="", $handle_entities = false)
 {
	if($handle_entities)
	{
		$string = $this->unhtmlentities($string);
	}
	if(function_exists("mb_substr"))
	{
		if($length != "")
		{
			$cut_string = mb_substr($string, $start, $length);
		}
		else
		{
			$cut_string = mb_substr($string, $start);
		}
	}
	else
	{
		if($length != "")
		{
			$cut_string = substr($string, $start, $length);
		}
		else
		{
			$cut_string = substr($string, $start);
		}
	}

	if($handle_entities)
	{
		$cut_string = $this->htmlspecialchars_uni($cut_string);
	}
	return $cut_string;
 }

	/**
	 * Custom function for htmlspecialchars which takes in to account unicode
	 *
	 * @param string The string to format
	 * @return string The string with htmlspecialchars applied
	 */
	function htmlspecialchars_uni($message)
	{
		$message = preg_replace("#&(?!\#[0-9]+;)#si", "&amp;", $message); // Fix & but allow unicode
		$message = str_replace("<", "&lt;", $message);
		$message = str_replace(">", "&gt;", $message);
		$message = str_replace("\"", "&quot;", $message);
		return $message;
	}

	/**
	 * Returns any html entities to their original character
	 *
	 * @param string The string to un-htmlentitize.
	 * @return int The un-htmlentitied' string.
	 */
	function unhtmlentities($string)
	{
		// Replace numeric entities
		$string = preg_replace('~&#x([0-9a-f]+);~ei', 'unichr(hexdec("\\1"))', $string);
		$string = preg_replace('~&#([0-9]+);~e', 'unichr("\\1")', $string);

		// Replace literal entities
		$trans_tbl = get_html_translation_table(HTML_ENTITIES);
		$trans_tbl = array_flip($trans_tbl);

		return strtr($string, $trans_tbl);
	}

	/**
	 * Finds a needle in a haystack and returns it position, mb strings accounted for
	 *
	 * @param string String to look in (haystack)
	 * @param string What to look for (needle)
	 * @param int (optional) How much to offset
	 * @return int false on needle not found, integer position if found
	 */
	function my_strpos($haystack, $needle, $offset=0)
	{
		if($needle == '')
		{
			return false;
		}

		if(function_exists("mb_strpos"))
		{
			$position = mb_strpos($haystack, $needle, $offset);
		}
		else
		{
			$position = strpos($haystack, $needle, $offset);
		}

		return $position;
	}

 // slurp all enabled feeds from the database
	function _RunFeedRss()
	{
		include('includes/FeedParser.php');
		global $PowerBB;

		$feeds_result = $PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['feeds'] . " WHERE options = '1'");
		while ($FeedsInfo = $PowerBB->DB->sql_fetch_array($feeds_result))
		{
			if ($FeedsInfo['feeds_time'] < $PowerBB->_CONF['now'] - $FeedsInfo['ttl'])
			{
					$this->FeedParser	  	= 	new FeedParser;


					     $this->FeedParser->parse($FeedsInfo['rsslink']);

				         $Items	= $this->FeedParser->getItems();
			   if ($Items)
				{
					      foreach($Items as $Item)
					      {
					       // Kill XSS & SQL Injection and clean the topic title
							$find = "{rss:link}";
							if(@stristr($FeedsInfo['text'],$find))
							{
							$LINK = "\n\n [url=".$Item['LINK']."]".$PowerBB->_CONF['template']['_CONF']['lang']['the_original_topic']."[/url]";
							}else{
							$LINK = "";
							}
							// $bad_characters: All ASCII characters below ASCII 32 (except 9, 10 and 13 (tab, newline and carrige return)).
							$bad_characters = array_diff(range(chr(0), chr(31)), array(chr(9), chr(10), chr(13)));

							$text = $PowerBB->functions->CleanVariable($text,'html');
							$text = $PowerBB->functions->CleanVariable($text,'sql');
							$text = $Item['CONTENT:ENCODED'].$LINK;
							$text= str_replace (array('\\', '\\n'), "", $text);
							$text = str_replace(array('"', "'"), array('&quot;', '&#39;'), $text);
							$text = str_replace($bad_characters, "", $text);
							$Item['TITLE'] = str_replace($bad_characters, "", $Item['TITLE']);
		                    $Item['TITLE'] 	= 	$PowerBB->functions->CleanVariable($Item['TITLE'],'html');
		                    $Item['TITLE'] 	= 	$PowerBB->functions->CleanVariable($Item['TITLE'],'sql');
							$MemberArr 			= 	array();
							$MemberArr['where'] 	= 	array('id',$FeedsInfo['userid']);
							$MemberInfo = $PowerBB->core->GetInfo($MemberArr,'member');

							$section = $FeedsInfo['forumid'];
							$ItemTitle	=	$Item['TITLE'];

							// Make sure that the topic does not exist before
							$exist_query = $PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['subject'] . " WHERE title = '$ItemTitle' and section = '$section'");
							$exist_row   = $PowerBB->DB->sql_fetch_array($exist_query);
						  if (!$exist_row)
						   {
							$SubjectArr	=	array();
							$SubjectArr['field']	=	array();
							$SubjectArr['field']['title']	=	$Item['TITLE'];
							$SubjectArr['field']['text']	=	$text;
							$SubjectArr['field']['writer']	=	$MemberInfo['username'];
							$SubjectArr['field']['write_time'] 			= 	$PowerBB->_CONF['now'];
							$SubjectArr['field']['native_write_time'] 	= 	$PowerBB->_CONF['now'];
							$SubjectArr['field']['icon'] 				= 	'look/images/icons/i1.gif';
							$SubjectArr['field']['section']	=	$FeedsInfo['forumid'];

							$Insert = $PowerBB->subject->InsertSubject($SubjectArr);


							// The overall number of Member posts
							$posts = $MemberInfo['posts'] + 1;
							$MemberArr 				= 	array();
							$MemberArr['field'] 	= 	array();
							$MemberArr['field']['posts']			=	$posts;
							$MemberArr['field']['lastpost_time'] 	=	$PowerBB->_CONF['now'];
							$MemberArr['where']						=	array('id',$MemberInfo['id']);
							$UpdateMember = $PowerBB->member->UpdateMember($MemberArr);

						   }

						}
						if($Insert)
						 {
							$feeds_time = $PowerBB->_CONF['now'];
							$feeds_id = $FeedsInfo['id'];
							$UpdateFeeds = $PowerBB->DB->sql_query("UPDATE " . $PowerBB->table['feeds'] . " SET feeds_time ='$feeds_time' where id = '$feeds_id'");

							$section = $FeedsInfo['forumid'];
							$info_query = $PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['subject'] . " WHERE id and section = '$section' ORDER BY id ASC");
							$info_row   = $PowerBB->DB->sql_fetch_array($info_query);
							$LastArr = array();
							$LastArr['writer'] 		= 	$info_row['writer'];
							$LastArr['title'] 		= 	$PowerBB->functions->CleanVariable($info_row['title'],'html');
							$LastArr['subject_id'] 	= 	$info_row['id'];
							$LastArr['date'] 		= 	$PowerBB->_CONF['date'];
							$LastArr['icon'] 		= 	'look/images/icons/i1.gif';
							$LastArr['where'] 		= 	(!$this->SectionInfo['sub_section']) ? array('id',$PowerBB->_POST['section']) : array('id',$this->SectionInfo['from_sub_section']);

							// Update Last subject's information
							$UpdateLast = $PowerBB->section->UpdateLastSubject($LastArr);


							$Upsubject_nm = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['subject'] . " WHERE section='$section'"));

							$SecArr 			= 	array();
							$SecArr['where'] 	= 	array('id',$FeedsInfo['forumid']);

							$this->SectionInfo = $PowerBB->core->GetInfo($SecArr,'section');

							//////////

							// The number of section's subjects number
							$UpdateArr 					= 	array();
							$UpdateArr['field']			=	array();

							$UpdateArr['field']['subject_num'] 	= 	$this->SectionInfo['subject_num'] + $Upsubject_nm;
							$UpdateArr['where']					= 	array('id',$FeedsInfo['forumid']);

							$UpdateSubjectNumber = $PowerBB->core->Update($UpdateArr,'section');

							//////////

							// Update section's cache
							$UpdateArr 				= 	array();
							$UpdateArr['parent'] 	= 	$this->SectionInfo['parent'];

							$update_cache = $PowerBB->section->UpdateSectionsCache($UpdateArr);
					    }
				}

			}
	     }

		//////////
   }

     // Visitor Today number
	function visitor_today_number()
	{
		global $PowerBB;
		  if ($PowerBB->_CONF['info_row']['show_online_list_today'])
		  {
		      if (!$PowerBB->_COOKIE[$PowerBB->_CONF['today_cookie']])
		  	  {

				@ob_start();
				@setcookie("PowerBB_today_date",$PowerBB->_CONF['date'], time()+3600*24);
				@ob_end_flush();

				$number = $PowerBB->_CONF['info_row']['today_number_cache'] + 1;

				$PowerBB->info->UpdateInfo(array('value'=>$number,'var_name'=>'today_number_cache'));
			  }
			  else
			  {
				if ($PowerBB->functions->IsCookie($PowerBB->_CONF['today_cookie']))
				 {
			      $today_cookie = $PowerBB->_COOKIE[$PowerBB->_CONF['today_cookie']];

				  if ($PowerBB->_CONF['info_row']['today_date_cache'] != $today_cookie)
				  {
					@ob_start();
					@setcookie("PowerBB_today_date",$PowerBB->_CONF['date'], time()+3600*24);
					@ob_end_flush();
				    $number = $PowerBB->_CONF['info_row']['today_number_cache'] + 1;
				    $PowerBB->info->UpdateInfo(array('value'=>$number,'var_name'=>'today_number_cache'));
				  }
                }
			  }
		  }
          /////

	}

	function get_hooks($place_of_hook)
	{
		global $PowerBB;
		if (!empty($place_of_hook))
		{
	      if($PowerBB->DISABLE_HOOKS)
	      {
            $HooksInfo = $PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['hooks'] . " WHERE place_of_hook = '$place_of_hook'");
 		     ////////////
		   // Loop to read the information of Hooks
            while ($Hook = $PowerBB->DB->sql_fetch_array($HooksInfo))
            {
			 $Hook['phpcode']=	str_replace("{sq}","'",$Hook['phpcode']);
			 $Hook['phpcode'] = stripslashes($Hook['phpcode']);

			 eval($Hook['phpcode']);
			 }

	      }
       }
	}

	function get_hooks_template($place_of_hook)
	{
		global $PowerBB;
		if (!empty($place_of_hook))
		{

	      if($PowerBB->DISABLE_HOOKS){

            $HooksInfo = $PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['hooks'] . " WHERE place_of_hook = '$place_of_hook'");
 		     ////////////
		   // Loop to read the information of Hooks
            while ($Hook = $PowerBB->DB->sql_fetch_array($HooksInfo))
            {
			 $Hook['phpcode']=	str_replace("{sq}","'",$Hook['phpcode']);
			 $Hook['phpcode'] = stripslashes($Hook['phpcode']);
			 eval("?>".$Hook['phpcode']."<?");
			 }

	      }

	   }
	}


 }

class PowerBBAdminFunctions extends PowerBBFunctions
{
 	//
}


?>
