<?php
(!defined('IN_PowerBB')) ? die() : '';
include('common.php');
define('CLASS_NAME','PowerBBForumMOD');
class PowerBBForumMOD
{


	function run()
	{
		global $PowerBB;
       $PowerBB->_GET['id']	= 	$PowerBB->functions->CleanVariable($PowerBB->_GET['id'],'intval');

		$PowerBB->template->assign('SECTION_RSS',true);
		$PowerBB->template->assign('SECTION_ID',$PowerBB->_GET['id']);

        $PowerBB->functions->get_hooks("forum_run_Hooks");

		/** Browse the forum **/
		if ($PowerBB->_GET['show'])
		{
    		$PowerBB->functions->ShowHeader();
			$this->_BrowseForum();
		}
		/** **/
		elseif ($PowerBB->_GET['password_check'])
		{
			$this->_PasswordCheck();
		}
		/** Show the results of search **/
		elseif ($PowerBB->_GET['start'])
		{
		    $PowerBB->functions->ShowHeader();
			$this->_SearchSection();
		}
		/** Show the subject order by (oldr - new )**/
		elseif($PowerBB->_GET['order'])
		{
		   $PowerBB->functions->ShowHeader();
			$this->_Startorder();
		}
		/** Show the subject order by (reply_number - visitor - rating)**/
        elseif($PowerBB->_GET['orderby'])
        {
		   $PowerBB->functions->ShowHeader();
         $this->_StartorderBy();
        }
        elseif($PowerBB->_GET['option'] == '1')
	    {
		  $PowerBB->functions->ShowHeader();
		 $this->_StartSearch();
		}
		else
		{
			$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['path_not_true']);
		}


		$PowerBB->functions->GetFooter();
	}

	/**
	 * Get all things about section , subjects of the sections , announcement and sub sections to show it
	 * Yes it's long list :\
	 */
	function _BrowseForum()
	{
		global $PowerBB;

		$this->_GeneralProcesses();

		$this->_SectionOnline();

		$this->_GetModeratorsList();

		$this->_GetAnnouncementList();

		$this->_GetSubSection();

		$this->_GetSubjectList();

		$this->_CallTemplate();

   		$this->_GetJumpSectionsList();

	}

	function _PasswordCheck()
	{
		global $PowerBB;
         if (empty($PowerBB->_COOKIE['pbb_sec'.$this->Section['id'].'_pass']))
         {
			if (empty($PowerBB->_POST['password']))
			{
				$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['PasswordCheck']);
			}

			$SecArr 			= 	array();
			$SecArr['where'] 	= 	array('id',$PowerBB->_GET['id']);

			$this->Section = $PowerBB->core->GetInfo($SecArr,'section');
	     	if ($PowerBB->_POST['password'] != $this->Section['section_password'])
	     	{
		         $PowerBB->functions->ShowHeader();
	     		$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['PasswordIsnotTrue']);
	     	}
	     	else
	     	{
				@ob_start();
				@setcookie("pbb_sec".$this->Section['id']."_pass",$PowerBB->_POST['password'], time()+3600);
				//@ob_end_flush();
	     	}

	       $PowerBB->functions->header_redirect($PowerBB->_SERVER['HTTP_REFERER']);
	     }
	}

	function _GeneralProcesses($check=false)
	{
		global $PowerBB;

		// Clean id from any strings
		$PowerBB->_GET['id'] = $PowerBB->functions->CleanVariable($PowerBB->_GET['id'],'intval');

		// No _GET['id'] , so ? show a small error :)
		if (empty($PowerBB->_GET['id']))
		{
			$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['path_not_true']);
		}

		// Get section information and set it in $this->Section
		$SecArr 			= 	array();
		$SecArr['where'] 	= 	array('id',$PowerBB->_GET['id']);

		$this->Section = $PowerBB->core->GetInfo($SecArr,'section');

		// Clear section information from any denger
		$PowerBB->functions->CleanVariable($this->Section,'html');

		$PowerBB->template->assign('section_info',$this->Section);

		/** Get section's group information and make some checks **/
		$SecGroupArr 						= 	array();
		$SecGroupArr['where'] 				= 	array();
		$SecGroupArr['where'][0]			=	array();
		$SecGroupArr['where'][0]['name'] 	= 	'section_id';
		$SecGroupArr['where'][0]['value'] 	= 	$this->Section['id'];
		$SecGroupArr['where'][1]			=	array();
		$SecGroupArr['where'][1]['con']		=	'AND';
		$SecGroupArr['where'][1]['name']	=	'group_id';
		$SecGroupArr['where'][1]['value']	=	$PowerBB->_CONF['group_info']['id'];

		// Finally get the permissions of group
		$this->SectionGroup = $PowerBB->core->GetInfo($SecGroupArr,'sectiongroup');

		// This section isn't exists
		if (!$this->Section)
		{
			$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['Section_does_not_exist']);
		}
		// This member can't view this section
		if ($this->SectionGroup['view_section'] != 1)
		{
			$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['can_not_view_section']);
		}

		// This is main section , so we can't get subjects list from it
		if ($this->Section['main_section'])
		{
			$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['thes_main_section']);
		}

		if ($PowerBB->_CONF['group_info']['view_section'] == 0)
		{
          if (!$PowerBB->_CONF['member_permission'])
              {
              $PowerBB->template->display('login');
              $PowerBB->functions->error_stop();
			}
	        else
	        {
			$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['can_not_view_section']);
	        }
		}

		// This section is link , so we should go to another site
		if ($this->Section['linksection'])
		{
   	        // The number of section's Visitors
			$SectionArr = array();
			$SectionArr['where'] = array('id',$PowerBB->_GET['id']);

			$SectionInfov = $PowerBB->core->GetInfo($SectionArr,'section');

			$SectionInfov['linkvisitor'] +=1;
	        $visitor = $SectionInfov['linkvisitor'];
			$Sectionid = $PowerBB->_GET['id'];
		    $update_visitor_Section = $PowerBB->DB->sql_query("UPDATE " . $PowerBB->table['section'] . " SET linkvisitor= '$visitor' WHERE id='$Sectionid'");

     		// Update section's cache
     		$UpdateArr 				= 	array();
     		$UpdateArr['parent'] 	= 	$SectionInfov['parent'];

     		$update_cache = $PowerBB->section->UpdateSectionsCache($UpdateArr);


		    $PowerBB->functions->msg($PowerBB->_CONF['template']['_CONF']['lang']['Please_wait_will_be_referred_to'] . $this->Section['linksite']);
			$PowerBB->functions->redirect($this->Section['linksite'],3);
			$PowerBB->functions->stop();
		}

		// hmmmm , this section protect by password so request the password
		if (!$check)
		{

			if (!empty($this->Section['section_password'])
				and !$PowerBB->_CONF['group_info']['admincp_allow']
				and !$PowerBB->functions->ModeratorCheck($this->Section['id']))
			{
     			if (empty($PowerBB->_COOKIE['pbb_sec'.$this->Section['id'].'_pass']))
        		{
      				$PowerBB->template->display('forum_password');
      				$PowerBB->functions->stop();
     			}
     			else
     			{
     				$PassArr = array();
     				$PassArr['id'] 			= 	$this->Section['id'];
     				$PassArr['password'] 	= 	($PowerBB->_GET['password'].$PowerBB->_COOKIE['pbb_sec'.$this->Section['id'].'_pass']);

     				$IsTruePassword = $PowerBB->section->CheckPassword($PassArr);

     				if (!$IsTruePassword)
     				{
     					$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['The_password_notTrue']);
     				}

     				$PowerBB->_CONF['template']['password'] = $password;
     			}
     		}
     	}

     	if ($PowerBB->_CONF['member_permission'])
     	{
     		$UpdateOnline 			= 	array();
			$UpdateOnline['field']	=	array();

			$UpdateOnline['field']['user_location'] 	= $PowerBB->_CONF['template']['_CONF']['lang']['Seen_the'] .	' <a href="index.php?page=forum&show=1&amp;id=' . $this->Section['id'] . '">' . $PowerBB->functions->CleanVariable($this->Section['title'],'sql') . '</a>';
			$UpdateOnline['field']['section_id'] 	    =  $this->Section['id'];
			$UpdateOnline['where']						=	array('username',$PowerBB->_CONF['member_row']['username']);

			$update = $PowerBB->core->Update($UpdateOnline,'online');
     	}
       else
     	{
     		$UpdateOnline 			= 	array();
			$UpdateOnline['field']	=	array();

			$UpdateOnline['field']['user_location'] 	= $PowerBB->_CONF['template']['_CONF']['lang']['Seen_the'] .	' <a href="index.php?page=forum&show=1&amp;id=' . $this->Section['id'] . '">' . $PowerBB->functions->CleanVariable($this->Section['title'],'sql') . '</a>';
			$UpdateOnline['field']['section_id'] 	    =  $this->Section['id'];
			$UpdateOnline['where']						=	array('user_ip',$PowerBB->_CONF['ip']);

			$update = $PowerBB->core->Update($UpdateOnline,'online');
     	}
	}

	/**
	 * Know who is in section ?
	 */
	function _SectionOnline()
	{
		global $PowerBB;

		// Finally we get Who is in section
		$SecArr 						= 	array();
		$SecArr['proc'] 				= 	array();
		$SecArr['proc']['*'] 			= 	array('method'=>'clean','param'=>'html');
		$SecArr['where']				=	array();

		$SecArr['where'][0]				=	array();
		$SecArr['where'][0]['name'] 	= 	'section_id';
		$SecArr['where'][0]['oper'] 	= 	'=';
		$SecArr['where'][0]['value'] 	= 	$PowerBB->_GET['id'];

		$SecArr['order'] 				= 	array();
		$SecArr['order']['field'] 		= 	'user_id';
		$SecArr['order']['type'] 		= 	'DESC';

		$SecArr['proc'] 						= 	array();
		$SecArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
		$SecArr['proc']['logged'] 			= 	array('method'=>'time','store'=>'logged','type'=>$PowerBB->_CONF['info_row']['timesystem']);


		$x = 1;

		if (!$PowerBB->_CONF['info_row']['show_onlineguest'])
		{
			$SecArr['where'][$x]				=	array();
			$SecArr['where'][$x]['con']			=	'AND';
			$SecArr['where'][$x]['name']		=	'username';
			$SecArr['where'][$x]['oper']		=	'<>';
			$SecArr['where'][$x]['value']		=	'Guest';

			$x += 1;
		}

		// This member can't see hidden member
		if (!$PowerBB->_CONF['group_info']['show_hidden'])
		{
			$SecArr['where'][$x] 			= 	array();
			$SecArr['where'][$x]['con'] 	= 	'AND';
			$SecArr['where'][$x]['name'] 	= 	'hide_browse';
			$SecArr['where'][$x]['oper'] 	= 	'<>';
			$SecArr['where'][$x]['value'] 	= 	'1';
		}

		$PowerBB->_CONF['template']['while']['SectionVisitor'] = $PowerBB->core->GetList($SecArr,'online');

		$GuestNumberArr 						= 	array();
		$GuestNumberArr['where'] 				= 	array();

		$GuestNumberArr['where'][0] 			= 	array();
		$GuestNumberArr['where'][0]['name'] 	= 	'username_style';
		$GuestNumberArr['where'][0]['oper'] 	= 	'=';
		$GuestNumberArr['where'][0]['value'] 	= 	'Guest';

		$GuestNumberArr['where'][1] 			= 	array();
		$GuestNumberArr['where'][1]['con'] 		= 	'AND';
		$GuestNumberArr['where'][1]['name'] 	= 	'section_id';
		$GuestNumberArr['where'][1]['oper'] 	= 	'=';
        $GuestNumberArr['where'][1]['value'] 	= 	$PowerBB->_GET['id'];

		$PowerBB->_CONF['template']['GuestNumber'] = $PowerBB->core->GetNumber($GuestNumberArr,'online');

		$MemberNumberArr 						= 	array();
		$MemberNumberArr['where'] 				= 	array();

		$MemberNumberArr['where'][0] 			= 	array();
		$MemberNumberArr['where'][0]['name'] 	= 	'username_style';
		$MemberNumberArr['where'][0]['oper'] 	= 	'<>';
		$MemberNumberArr['where'][0]['value'] 	= 	'Guest';

		$MemberNumberArr['where'][1] 			= 	array();
		$MemberNumberArr['where'][1]['con'] 	= 	'AND';
		$MemberNumberArr['where'][1]['name'] 	= 	'section_id';
		$MemberNumberArr['where'][1]['oper'] 	= 	'=';
		$MemberNumberArr['where'][1]['value'] 	= 	$PowerBB->_GET['id'];

		$PowerBB->_CONF['template']['MemberNumber'] = $PowerBB->core->GetNumber($MemberNumberArr,'online');

		$online_number = $PowerBB->core->GetNumber($GuestNumberArr,'online')+$PowerBB->core->GetNumber($MemberNumberArr,'online');
       $PowerBB->template->assign('online_number',$online_number);
	}

	function _GetModeratorsList()
	{
		global $PowerBB;

		$ModArr 			= 	array();
		$ModArr['where'] 	= 	array('section_id',$this->Section['id']);

		$PowerBB->_CONF['template']['while']['ModeratorsList'] = $PowerBB->core->GetList($ModArr,'moderators');

		if (is_array($PowerBB->_CONF['template']['while']['ModeratorsList'])
			and sizeof($PowerBB->_CONF['template']['while']['ModeratorsList']) > 0)
		{
			$PowerBB->template->assign('STOP_MODERATOR_TEMPLATE',false);
		}
		else
		{
			$PowerBB->template->assign('STOP_MODERATOR_TEMPLATE',true);
		}
	}

	/**
	 * Get announcement list
	 */
	function _GetAnnouncementList()
	{
		global $PowerBB;

		$AnnArr 					= 	array();

		$AnnArr['proc'] 			= 	array();
		$AnnArr['proc']['*'] 		= 	array('method'=>'clean','param'=>'html');
		$AnnArr['proc']['date'] 	= 	array('method'=>'date','type'=>$PowerBB->_CONF['info_row']['timesystem']);

		$AnnArr['order']			=	array();
		$AnnArr['order']['field']	=	'id';
		$AnnArr['order']['type']	=	'DESC';


		$PowerBB->_CONF['template']['while']['AnnouncementList'] = $PowerBB->core->GetList($AnnArr,'announcement');

		if ($PowerBB->_CONF['template']['while']['AnnouncementList'] != false)
		{
			$PowerBB->template->assign('STOP_ANNOUNCEMENT_TEMPLATE',false);
		}
		else
		{
			$PowerBB->template->assign('STOP_ANNOUNCEMENT_TEMPLATE',true);
		}
	}

	function _GetSubSection()
	{
		global $PowerBB;

			@include("cache/forums_cache_".$this->Section['id'].".php");
			if (!empty($forums_cache['forums_cache']))
			{
                $forums = unserialize(base64_decode($forums_cache['forums_cache']));

					foreach ($forums as $forum)
					{
						//////////////////////////
					     @include("cache/sectiongroup_cache".$forum['id'].".php");
						$groups = unserialize(base64_decode($sectiongroup_cache['sectiongroup_cache']));
						if ($groups[$PowerBB->_CONF['group_info']['id']]['view_section'])
						{
                           if (!empty($forum['last_date']))
                           {
							$forum_last_time1 = $forum['last_date'];
							$forum['last_subject'] = $PowerBB->Powerparse->censor_words($forum['last_subject']);
							$forum['last_subject'] =  $PowerBB->Powerparse->_wordwrap($forum['last_subject'],'60');
							$forum['last_post_date'] = $forum['last_time'];
							$forum['last_date'] = $PowerBB->sys_functions->time_ago($forum_last_time1);
							$forum['last_subjectid'] = $forum['last_subjectid'];
							$forum['last_time'] = $forum['last_time'];
							$forum['last_reply'] = $forum['last_reply'];
							$forum['icon'] = $forum['icon'];
							$forum['review_subject'] = $forum['review_subject'];
							$forum['last_berpage_nm'] = $forum['last_berpage_nm'];
							$forum['last_writer']= $forum['last_writer'];
							$forum['last_subject'] =  stripslashes($forum['last_subject']);
                           }
                            $forum['subject_num'] = $PowerBB->functions->with_comma($forum['subject_num']);
                            $forum['reply_num'] = $PowerBB->functions->with_comma($forum['reply_num']);

							// Get the number of subjects and replys hidden for Moderators
							if ($PowerBB->functions->ModeratorCheck($forum['id']))
							{
				               if ($forum['subjects_review_num']>0)
								{
								$forum['num_subjects_awaiting_approval'] =	$PowerBB->functions->with_comma($forum['subjects_review_num']);
								}
	                           if ($forum['replys_review_num']>0)
								{
								$forum['num_replys_awaiting_approval'] =	$PowerBB->functions->with_comma($forum['replys_review_num']);
								}
					        }


		                    if ($PowerBB->_CONF['info_row']['no_sub'])
						    {
								$forum['is_sub'] 	= 	0;
								$forum['sub']		=	'';

										$t=0;
										$forum['sub'] .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" width=\"100%\"><tr valign=\"top\"> ";
			                        @include("cache/forums_cache_".$forum['id'].".php");
                                   if (!empty($forums_cache['forums_cache']))
		                           {

										$subs = unserialize(base64_decode($forums_cache['forums_cache']));
		                               foreach($subs as $sub)
										{
										   if ($forum['id'] == $sub['parent'])
		                                    {
									            @include("cache/sectiongroup_cache".$sub['id'].".php");
										        $groups = unserialize(base64_decode($sectiongroup_cache['sectiongroup_cache']));

										        if (!empty($sub['last_date']))
										         {
										           if ($forum['last_time']< $sub['last_time'])
										           {
	                                             	$forum_last_time1 = $sub['last_date'];
													$forum['last_subject'] = $PowerBB->Powerparse->censor_words($sub['last_subject']);
													$forum['last_subject'] =  $PowerBB->Powerparse->_wordwrap($sub['last_subject'],'60');
													$forum['last_post_date'] = $sub['last_time'];
				                                    if($sub['subject_num'] > 0)
				                                    {
													$forum['last_date'] = $PowerBB->sys_functions->time_ago($forum_last_time1);
	                                                }
													$forum['last_subjectid'] = $sub['last_subjectid'];
													$forum['last_time'] = $sub['last_time'];
													$forum['last_reply'] = $sub['last_reply'];
													$forum['icon'] = $sub['icon'];
													$forum['review_subject'] = $sub['review_subject'];
													$forum['last_berpage_nm'] = $sub['last_berpage_nm'];
													$forum['last_writer']= $sub['last_writer'];
								                    $forum['last_subject'] =  stripslashes($sub['last_subject']);
								                  }
                                               }
			                                        $forum_subject_num = $forum['subject_num']+ $sub['subject_num'];
			                                        $forum_reply_num =  $forum['reply_num']+ $sub['reply_num'];
			                                        $forum['subject_num']   = $PowerBB->functions->with_comma($forum_subject_num);
			                                        $forum['reply_num']   = $PowerBB->functions->with_comma($forum_reply_num);

												  if ($groups[$PowerBB->_CONF['group_info']['id']]['view_section'])
												   {
														 $forum_title_color = "'".$sub['forum_title_color']."'";
														 $sub['title'] = "<font color=".$forum_title_color.">".stripslashes($sub['title'])."</font>";
														if ($sub['id'])
														{
														$forum['is_sub'] = 1;
														}
														if($t== $PowerBB->_CONF['info_row']['sub_columns_number']){
														$t=0;
														$forum['sub'] .="</tr><tr>";
														}
														$forum_url = "index.php?page=forum&amp;show=1&amp;id=";
														$forum['sub'] .= "<td>";
														$forum['sub'] .= '<a href="'.$PowerBB->functions->rewriterule($forum_url).$sub['id'].'"><img border="0" alt="" src="' . $PowerBB->_CONF['template']['image_path'] . '/address_bar_start.gif" />'.$sub['title'].'</a>';
														$forum['sub'] .= "&nbsp;</td>";
														$t=$t+1;

											        }
											  }
										 }
									    	$forum['sub'] .="</tr></table>";


								   }
		                     }
						   //////////


							// get writer username style cache And  writer photo
	                         $username = $forum['last_writer'];
	                      if ($username !='Guest')
                            {
							   if ($PowerBB->_CONF['info_row']['get_group_username_style'])
							     {
									if (!empty($username))
									{
							   		// Get username style
									$MemberArr 			= 	array();
									$MemberArr['where'] 	= 	array('username',$username);

									$StyleMemberInfo = $PowerBB->core->GetInfo($MemberArr,'member');
							        $username = $StyleMemberInfo['username_style_cache'];
							        $user_id = $StyleMemberInfo['id'];
									if ($PowerBB->_CONF['info_row']['allow_avatar'])
									{
                                       // Get writer photo
								        if (!$StyleMemberInfo['avater_path'])
								        {
							            $avater_path = $PowerBB->_CONF['template']['image_path'].'/'.$PowerBB->_CONF['info_row']['default_avatar'];
							            }
							            else
								        {
							            $avater_path = $StyleMemberInfo['avater_path'];
							            }
									   $writer_photo_thumb = '<a href="index.php?page=profile&amp;show=1&amp;id=' . $user_id . '"><img src="' . $avater_path . '" alt="photo" class="UserPhoto_mini" /></a>';
									   $forum['writer_photo_thumb'] = $writer_photo_thumb ;

							        }
									 $username = '<a href="index.php?page=profile&amp;show=1&amp;id=' . $user_id . '">' . $username . '</a> ';
									 $forum['last_writer'] = $PowerBB->functions->rewriterule($username);
								  }
								  else
								  {
									 $forum['last_writer'] = $username;
							      }

							  }
							  else
							  {
								 $username = '<a href="index.php?page=profile&amp;show=1&amp;username=' . $username . '">' . $username . '</a> ';
								 $forum['last_writer'] = $PowerBB->functions->rewriterule($username);
							  }

							}
							else
							{
								$writer_photo_thumb = '<img src="' . $PowerBB->_CONF['template']['image_path'].'/'.$PowerBB->_CONF['info_row']['default_avatar'] . '" alt="photo" class="UserPhoto_mini" /></a>';
								 $forum['writer_photo_thumb'] = $writer_photo_thumb ;
							}
	                          //

						  // Get the moderators list as a _link_ and store it in $forum['moderators_list']
		                   if ($PowerBB->_CONF['info_row']['no_moderators'])
						   {
								$forum['is_moderators'] 		= 	0;
								$forum['moderators_list']		=	'';

								if (!empty($forum['moderators']))
								{
									$moderators = unserialize($forum['moderators']);

									if (is_array($moderators))
									{
		                               foreach($moderators as $moderator)
										{
											if (!$forum['is_moderators'])
											{
												$forum['is_moderators'] = 1;
											}
										               if ($PowerBB->_CONF['info_row']['rewriterule'] == '1')
														{
														$forum['moderators_list'] .= '<a href="u' . $moderator['member_id'] . '.html">' . $PowerBB->functions->GetUsernameStyle($moderator['username']) . '</a> , ';
														}
														else
														{
											            $forum['moderators_list'] .= '<a href="index.php?page=profile&amp;show=1&amp;id=' . $moderator['member_id'] . '">' . $PowerBB->functions->GetUsernameStyle($moderator['username']) .'</a> , ';
														}
										}
									}
								}

                               $PowerBB->template->assign('colspan_mod',"4");
		                    }
		                    else
		                    {
		                    	$PowerBB->template->assign('colspan_mod',"3");
		                    }
							//////////


							// Get online forums
							if ($PowerBB->_CONF['info_row']['active_forum_online_number'])
							{
							$Forum_online_number = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['online'] . " WHERE section_id='" . $forum['id'] . "'"));
							$forum['forum_online'] = $Forum_online_number;
							}

							 $forum_title_color = "'".$forum['forum_title_color']."'";
							 $forum['title'] = "<font color=".$forum_title_color.">".$forum['title']."</font>";
							$PowerBB->_CONF['template']['foreach']['forums_list'][$forum['id'] . '_f'] = $forum;
							unset($groups);

						}// end view forums
		             } // end foreach ($forums)

			 $PowerBB->template->assign('SHOW_SUB_SECTIONS',true);
			} // end !empty($forums_cache)
			else
			{
				$PowerBB->template->assign('SHOW_SUB_SECTIONS',false);
			}
	   $PowerBB->template->assign('Section_Title',$this->Section['title']);
       $PowerBB->template->assign('Section_Id',$this->Section['id']);
       $PowerBB->functions->get_hooks("forumdHooks");

	}

	  /**
	 * /** Show the subject order by (reply_number - visitor - rating)**/
	function _StartorderBy()
	{

	global $PowerBB;

       if ($this->Section['password'] !='')
        {
     	  $password = '&amp;password=' . $PowerBB->_GET['password'];
        }

		if (isset($PowerBB->_GET['sort']))
		{
       	if ($PowerBB->_GET['sort'] != 'desc'
       	and $PowerBB->_GET['sort'] != 'asc'
       	and $PowerBB->_GET['sort'] != 'reply_number'
       	and $PowerBB->_GET['sort'] != 'visitor'
       	and $PowerBB->_GET['sort'] != 'rating'
       	and $PowerBB->_GET['sort'] != 'writer'
       	and $PowerBB->_GET['sort'] != 'write_time'
       	and $PowerBB->_GET['sort'] != 'title')
		{

			$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['path_not_true']);

	   // $PowerBB->functions->redirect('index.php?page=forum&amp;show=1&amp;id=' . $PowerBB->_GET['id']);

		}
      }
		/**
		 * Ok , are you ready to get subjects list ? :)
		 */

		$TotalArr 				= 	array();
		$TotalArr['get_from'] 	= 	'db';
		$TotalArr['where'] 		= 	array('section',$this->Section['id']);

		$SubjectArr = array();

		$SubjectArr['where'] 				= 	array();

		$SubjectArr['where'][0] 			= 	array();
		$SubjectArr['where'][0]['name'] 	= 	'section';
		$SubjectArr['where'][0]['oper'] 	= 	'=';
		$SubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

		$SubjectArr['where'][1] 			= 	array();
		$SubjectArr['where'][1]['con']		=	'AND';
		$SubjectArr['where'][1]['name'] 	= 	'stick';
		$SubjectArr['where'][1]['oper'] 	= 	'<>';
		$SubjectArr['where'][1]['value'] 	= 	'1';

		$SubjectArr['where'][2] 			= 	array();
		$SubjectArr['where'][2]['con']		=	'AND';
		$SubjectArr['where'][2]['name'] 	= 	'delete_topic';
		$SubjectArr['where'][2]['oper'] 	= 	'<>';
		$SubjectArr['where'][2]['value'] 	= 	'1';

		$SubjectArr['where'][3] 			= 	array();
		$SubjectArr['where'][3]['con']		=	'AND';
		$SubjectArr['where'][3]['name'] 	= 	'review_subject';
		$SubjectArr['where'][3]['oper'] 	= 	'<>';
		$SubjectArr['where'][3]['value'] 	= 	'1';

		if ($this->Section['hide_subject']
			and ! $PowerBB->functions->ModeratorCheck($this->Section['id']))
		{
			$SubjectArr['where'][4] 			= 	array();
			$SubjectArr['where'][4]['con'] 		= 	'AND';
			$SubjectArr['where'][4]['name'] 	= 	'writer';
			$SubjectArr['where'][4]['oper'] 	= 	'=';
			$SubjectArr['where'][4]['value'] 	= 	$PowerBB->_CONF['member_row']['username'];
		}

		$SubjectArr['order'] = array();

		if ($PowerBB->_GET['sort'] == 'reply_number')
		{
			$SubjectArr['order']['field'] 	= 	'reply_number';
			$SubjectArr['order']['type'] 	= 	'DESC';
		}
		elseif ($PowerBB->_GET['sort'] == 'visitor')
		{
			$SubjectArr['order']['field'] 	= 	'visitor';
			$SubjectArr['order']['type'] 	= 	'DESC';
		}
		elseif ($PowerBB->_GET['sort'] == 'rating')
		{
			$SubjectArr['order']['field'] 	= 	'rating';
			$SubjectArr['order']['type'] 	= 	'DESC';
		}
		elseif ($PowerBB->_GET['sort'] == 'writer')
		{
			$SubjectArr['order']['field'] 	= 	'writer';
			$SubjectArr['order']['type'] 	= 	'DESC';
		}
		elseif ($PowerBB->_GET['sort'] == 'title')
		{
			$SubjectArr['order']['field'] 	= 	'title';
			$SubjectArr['order']['type'] 	= 	'DESC';
		}
		else
		{
			$SubjectArr['order']['field'] 	= 	'write_time';
			$SubjectArr['order']['type'] 	= 	'DESC';
		}


		$PowerBB->_GET['count'] = (!isset($PowerBB->_GET['count'])) ? 0 : $PowerBB->_GET['count'];
		$PowerBB->_GET['count'] = $PowerBB->functions->CleanVariable($PowerBB->_GET['count'],'intval');

		$SubjectArr['proc'] 						= 	array();
		// Ok Mr.XSS go to hell !
		$SubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
		$SubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
		$SubjectArr['proc']['write_time'] 			= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);



		// Pager setup
		$SubjectArr['pager'] 				= 	array();
		$SubjectArr['pager']['total']		= 	$PowerBB->core->GetNumber($TotalArr,'subject');
		$SubjectArr['pager']['perpage'] 	= 	$PowerBB->_CONF['info_row']['subject_perpage'];
		$SubjectArr['pager']['count'] 		= 	$PowerBB->_GET['count'];
		$SubjectArr['pager']['location'] 	= 	'index.php?page=forum&amp;show=1&amp;id=' . $this->Section['id'] . $password;
		$SubjectArr['pager']['var'] 		= 	'count';

		$PowerBB->_CONF['template']['while']['subject_list'] = $PowerBB->core->GetList($SubjectArr,'subject');


				//////////

		$StickSubjectArr = array();

		$StickSubjectArr['where'] 				= 	array();

		$StickSubjectArr['where'][0] 			= 	array();
		$StickSubjectArr['where'][0]['name'] 	= 	'section';
		$StickSubjectArr['where'][0]['oper'] 	= 	'=';
		$StickSubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

		$StickSubjectArr['where'][1] 			= 	array();
		$StickSubjectArr['where'][1]['con']		=	'AND';
		$StickSubjectArr['where'][1]['name'] 	= 	'stick';
		$StickSubjectArr['where'][1]['oper'] 	= 	'=';
		$StickSubjectArr['where'][1]['value'] 	= 	'1';

		$StickSubjectArr['where'][2] 			= 	array();
		$StickSubjectArr['where'][2]['con']		=	'AND';
		$StickSubjectArr['where'][2]['name'] 	= 	'delete_topic';
		$StickSubjectArr['where'][2]['oper'] 	= 	'<>';
		$StickSubjectArr['where'][2]['value'] 	= 	'1';

		$StickSubjectArr['order'] = array();
		$StickSubjectArr['order']['field'] 	= 	'write_time';
		$StickSubjectArr['order']['type'] 	= 	'DESC';

		$StickSubjectArr['proc'] 						= 	array();
		// Ok Mr.XSS go to hell !
		$StickSubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
		$StickSubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
		$StickSubjectArr['proc']['write_time'] 			= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);

		$PowerBB->_CONF['template']['while']['stick_subject_list'] = $PowerBB->core->GetList($StickSubjectArr,'subject');

		if (sizeof($PowerBB->_CONF['template']['while']['stick_subject_list']) <= 0)
		{
			$PowerBB->template->assign('NO_STICK_SUBJECTS',true);
		}
		else
		{
			$PowerBB->template->assign('NO_STICK_SUBJECTS',false);
		}

		//////////

		// Get the list of subjects that need review

		if ($PowerBB->functions->ModeratorCheck($this->Section['id']))
		{
			$ReviewSubjectArr = array();

			$ReviewSubjectArr['where'] 				= 	array();

			$ReviewSubjectArr['where'][0] 			= 	array();
			$ReviewSubjectArr['where'][0]['name'] 	= 	'section';
			$ReviewSubjectArr['where'][0]['oper'] 	= 	'=';
			$ReviewSubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

			$ReviewSubjectArr['where'][1] 			= 	array();
			$ReviewSubjectArr['where'][1]['con']	=	'AND';
			$ReviewSubjectArr['where'][1]['name'] 	= 	'review_subject';
			$ReviewSubjectArr['where'][1]['oper'] 	= 	'=';
			$ReviewSubjectArr['where'][1]['value'] 	= 	'1';

			$ReviewSubjectArr['where'][2] 			= 	array();
			$ReviewSubjectArr['where'][2]['con']	=	'AND';
			$ReviewSubjectArr['where'][2]['name'] 	= 	'delete_topic';
			$ReviewSubjectArr['where'][2]['oper'] 	= 	'<>';
			$ReviewSubjectArr['where'][2]['value'] 	= 	'1';

			$ReviewSubjectArr['order'] 				= 	array();
			$ReviewSubjectArr['order']['field'] 	= 	'write_time';
			$ReviewSubjectArr['order']['type'] 		= 	'DESC';

			$ReviewSubjectArr['proc'] 						= 	array();
			// Ok Mr.XSS go to hell !
			$ReviewSubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
			$ReviewSubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
			$ReviewSubjectArr['proc']['write_time'] 		= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);

			$PowerBB->_CONF['template']['while']['review_subject_list'] = $PowerBB->core->GetList($ReviewSubjectArr,'subject');

			if (sizeof($PowerBB->_CONF['template']['while']['review_subject_list']) <= 0)
			{
				$PowerBB->template->assign('NO_REVIEW_SUBJECTS',true);
			}
			else
			{
				$PowerBB->template->assign('NO_REVIEW_SUBJECTS',false);
			}
		}
		else
		{
			$PowerBB->template->assign('NO_REVIEW_SUBJECTS',true);
		}

		//////////

		if ($PowerBB->core->GetNumber($TotalArr,'subject') > $PowerBB->_CONF['info_row']['subject_perpage'])
		{
				$PowerBB->template->assign('pager','1');
		}

		$PowerBB->template->assign('section_id',$this->Section['id']);

	}

	  	/**
	 * order subject in forum
	 */
	function _Startorder()
	{
		global $PowerBB;
       if ($this->Section['password'] !='')
        {
     	  $password = '&amp;password=' . $PowerBB->_GET['password'];
        }
		if (isset($PowerBB->_GET['sort']))
		{
       	if ($PowerBB->_GET['sort'] != 'desc'
       	and $PowerBB->_GET['sort'] != 'asc'
       	and $PowerBB->_GET['sort'] != 'reply_number'
       	and $PowerBB->_GET['sort'] != 'visitor'
       	and $PowerBB->_GET['sort'] != 'rating'
       	and $PowerBB->_GET['sort'] != 'writer'
       	and $PowerBB->_GET['sort'] != 'write_time'
       	and $PowerBB->_GET['sort'] != 'title')
		{

			$PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['path_not_true']);

	   // $PowerBB->functions->redirect('index.php?page=forum&amp;show=1&amp;id=' . $PowerBB->_GET['id']);

		}
      }

		/**
		 * Ok , are you ready to get subjects list ? :)
		 */
		$TotalArr 				= 	array();
		$TotalArr['get_from'] 	= 	'db';
		$TotalArr['where'] 		= 	array('section',$this->Section['id']);

		$SubjectArr = array();

		$SubjectArr['where'] 				= 	array();

		$SubjectArr['where'][0] 			= 	array();
		$SubjectArr['where'][0]['name'] 	= 	'section';
		$SubjectArr['where'][0]['oper'] 	= 	'=';
		$SubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

		$SubjectArr['where'][1] 			= 	array();
		$SubjectArr['where'][1]['con']		=	'AND';
		$SubjectArr['where'][1]['name'] 	= 	'stick';
		$SubjectArr['where'][1]['oper'] 	= 	'<>';
		$SubjectArr['where'][1]['value'] 	= 	'1';

		$SubjectArr['where'][2] 			= 	array();
		$SubjectArr['where'][2]['con']		=	'AND';
		$SubjectArr['where'][2]['name'] 	= 	'delete_topic';
		$SubjectArr['where'][2]['oper'] 	= 	'<>';
		$SubjectArr['where'][2]['value'] 	= 	'1';

		$SubjectArr['where'][3] 			= 	array();
		$SubjectArr['where'][3]['con']		=	'AND';
		$SubjectArr['where'][3]['name'] 	= 	'review_subject';
		$SubjectArr['where'][3]['oper'] 	= 	'<>';
		$SubjectArr['where'][3]['value'] 	= 	'1';

		if ($this->Section['hide_subject']
			and ! $PowerBB->functions->ModeratorCheck($this->Section['id']))
		{
			$SubjectArr['where'][4] 			= 	array();
			$SubjectArr['where'][4]['con'] 		= 	'AND';
			$SubjectArr['where'][4]['name'] 	= 	'writer';
			$SubjectArr['where'][4]['oper'] 	= 	'=';
			$SubjectArr['where'][4]['value'] 	= 	$PowerBB->_CONF['member_row']['username'];
		}

		$SubjectArr['order'] = array();

		if ($this->Section['subject_order'] == 2)
		{
			$SubjectArr['order']['field'] 	= 	'id';
			$SubjectArr['order']['type'] 	= 	$PowerBB->_GET['sort'];
		}
		elseif ($this->Section['subject_order'] == 3)
		{
			$SubjectArr['order']['field'] 	= 	'id';
			$SubjectArr['order']['type'] 	= 	'ASC';
		}
		else
		{
			$SubjectArr['order']['field'] 	= 	'write_time';
			$SubjectArr['order']['type'] 	= 	$PowerBB->_GET['sort'];
		}

		$PowerBB->_GET['count'] = (!isset($PowerBB->_GET['count'])) ? 0 : $PowerBB->_GET['count'];
		$PowerBB->_GET['count'] = $PowerBB->functions->CleanVariable($PowerBB->_GET['count'],'intval');

		$SubjectArr['proc'] 						= 	array();
		// Ok Mr.XSS go to hell !
		$SubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
		$SubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
		$SubjectArr['proc']['write_time'] 			= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);



		// Pager setup
		$SubjectArr['pager'] 				= 	array();
		$SubjectArr['pager']['total']		= 	$PowerBB->core->GetNumber($TotalArr,'subject');
		$SubjectArr['pager']['perpage'] 	= 	$PowerBB->_CONF['info_row']['subject_perpage'];
		$SubjectArr['pager']['count'] 		= 	$PowerBB->_GET['count'];
		$SubjectArr['pager']['location'] 	= 	'index.php?page=forum&amp;show=1&amp;id=' . $this->Section['id'] . $password;
		$SubjectArr['pager']['var'] 		= 	'count';

		$PowerBB->_CONF['template']['while']['subject_list'] = $PowerBB->core->GetList($SubjectArr,'subject');

				//////////

		$StickSubjectArr = array();

		$StickSubjectArr['where'] 				= 	array();

		$StickSubjectArr['where'][0] 			= 	array();
		$StickSubjectArr['where'][0]['name'] 	= 	'section';
		$StickSubjectArr['where'][0]['oper'] 	= 	'=';
		$StickSubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

		$StickSubjectArr['where'][1] 			= 	array();
		$StickSubjectArr['where'][1]['con']		=	'AND';
		$StickSubjectArr['where'][1]['name'] 	= 	'stick';
		$StickSubjectArr['where'][1]['oper'] 	= 	'=';
		$StickSubjectArr['where'][1]['value'] 	= 	'1';

		$StickSubjectArr['where'][2] 			= 	array();
		$StickSubjectArr['where'][2]['con']		=	'AND';
		$StickSubjectArr['where'][2]['name'] 	= 	'delete_topic';
		$StickSubjectArr['where'][2]['oper'] 	= 	'<>';
		$StickSubjectArr['where'][2]['value'] 	= 	'1';

		$StickSubjectArr['order'] = array();
		$StickSubjectArr['order']['field'] 	= 	'write_time';
		$StickSubjectArr['order']['type'] 	= 	'DESC';

		$StickSubjectArr['proc'] 						= 	array();
		// Ok Mr.XSS go to hell !
		$StickSubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
		$StickSubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
		$StickSubjectArr['proc']['write_time'] 			= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);

		$PowerBB->_CONF['template']['while']['stick_subject_list'] = $PowerBB->core->GetList($StickSubjectArr,'subject');

		if (sizeof($PowerBB->_CONF['template']['while']['stick_subject_list']) <= 0)
		{
			$PowerBB->template->assign('NO_STICK_SUBJECTS',true);
		}
		else
		{
			$PowerBB->template->assign('NO_STICK_SUBJECTS',false);
		}

		//////////

		// Get the list of subjects that need review

		if ($PowerBB->functions->ModeratorCheck($this->Section['id']))
		{
			$ReviewSubjectArr = array();

			$ReviewSubjectArr['where'] 				= 	array();

			$ReviewSubjectArr['where'][0] 			= 	array();
			$ReviewSubjectArr['where'][0]['name'] 	= 	'section';
			$ReviewSubjectArr['where'][0]['oper'] 	= 	'=';
			$ReviewSubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

			$ReviewSubjectArr['where'][1] 			= 	array();
			$ReviewSubjectArr['where'][1]['con']	=	'AND';
			$ReviewSubjectArr['where'][1]['name'] 	= 	'review_subject';
			$ReviewSubjectArr['where'][1]['oper'] 	= 	'=';
			$ReviewSubjectArr['where'][1]['value'] 	= 	'1';

			$ReviewSubjectArr['where'][2] 			= 	array();
			$ReviewSubjectArr['where'][2]['con']	=	'AND';
			$ReviewSubjectArr['where'][2]['name'] 	= 	'delete_topic';
			$ReviewSubjectArr['where'][2]['oper'] 	= 	'<>';
			$ReviewSubjectArr['where'][2]['value'] 	= 	'1';

			$ReviewSubjectArr['order'] 				= 	array();
			$ReviewSubjectArr['order']['field'] 	= 	'write_time';
			$ReviewSubjectArr['order']['type'] 		= 	'DESC';

			$ReviewSubjectArr['proc'] 						= 	array();
			// Ok Mr.XSS go to hell !
			$ReviewSubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
			$ReviewSubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
			$ReviewSubjectArr['proc']['write_time'] 		= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);

			$PowerBB->_CONF['template']['while']['review_subject_list'] = $PowerBB->core->GetList($ReviewSubjectArr,'subject');

			if (sizeof($PowerBB->_CONF['template']['while']['review_subject_list']) <= 0)
			{
				$PowerBB->template->assign('NO_REVIEW_SUBJECTS',true);
			}
			else
			{
				$PowerBB->template->assign('NO_REVIEW_SUBJECTS',false);
			}
		}
		else
		{
			$PowerBB->template->assign('NO_REVIEW_SUBJECTS',true);
		}

		//////////

		if ($PowerBB->core->GetNumber($TotalArr,'subject') > $PowerBB->_CONF['info_row']['subject_perpage'])
		{
				$PowerBB->template->assign('pager','1');

		}

		$PowerBB->template->assign('section_id',$this->Section['id']);

	}

	function _GetSubjectList()
	{
		global $PowerBB;


		$PowerBB->_GET['count'] = (!isset($PowerBB->_GET['count'])) ? 0 : $PowerBB->_GET['count'];
		$PowerBB->_GET['count'] = $PowerBB->functions->CleanVariable($PowerBB->_GET['count'],'intval');
        $PowerBB->functions->get_hooks("forum_subjectlist_Hooks");

       if ($this->Section['password'] !='')
        {
     	  $password = '&amp;password=' . $PowerBB->_GET['password'];
        }

		/** Show the subject order by (oldr - new )**/
		if($PowerBB->_GET['order'])
		{
			$this->_Startorder();
		}
		/** Show the subject order by (reply_number - visitor - rating)**/
        elseif($PowerBB->_GET['orderby'])
        {
         $this->_StartorderBy();
        }
        else
        {

		/**
		 * Ok , are you ready to get subjects list ? :)
		 */
		$TotalArr 				= 	array();
		$TotalArr['get_from'] 	= 	'db';
		$TotalArr['where'] 		= 	array('section',$this->Section['id']);

		$SubjectArr = array();

		$SubjectArr['where'] 				= 	array();

		$SubjectArr['where'][0] 			= 	array();
		$SubjectArr['where'][0]['name'] 	= 	'section';
		$SubjectArr['where'][0]['oper'] 	= 	'=';
		$SubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

		$SubjectArr['where'][1] 			= 	array();
		$SubjectArr['where'][1]['con']		=	'AND';
		$SubjectArr['where'][1]['name'] 	= 	'stick';
		$SubjectArr['where'][1]['oper'] 	= 	'<>';
		$SubjectArr['where'][1]['value'] 	= 	'1';

		$SubjectArr['where'][2] 			= 	array();
		$SubjectArr['where'][2]['con']		=	'AND';
		$SubjectArr['where'][2]['name'] 	= 	'review_subject';
		$SubjectArr['where'][2]['oper'] 	= 	'<>';
		$SubjectArr['where'][2]['value'] 	= 	'1';
        if (!$PowerBB->functions->ModeratorCheck($this->Section['id']))
   		{
		$SubjectArr['where'][3] 			= 	array();
		$SubjectArr['where'][3]['con']		=	'AND';
		$SubjectArr['where'][3]['name'] 	= 	'delete_topic';
		$SubjectArr['where'][3]['oper'] 	= 	'<>';
		$SubjectArr['where'][3]['value'] 	= 	'1';
        }

		if ($this->Section['hide_subject']
			and ! $PowerBB->functions->ModeratorCheck($this->Section['id']))
		{
			$SubjectArr['where'][3] 			= 	array();
			$SubjectArr['where'][3]['con'] 		= 	'AND';
			$SubjectArr['where'][3]['name'] 	= 	'writer';
			$SubjectArr['where'][3]['oper'] 	= 	'=';
			$SubjectArr['where'][3]['value'] 	= 	$PowerBB->_CONF['member_row']['username'];
		}

		$SubjectArr['order'] = array();

		if ($this->Section['subject_order'] == 2)
		{
			$SubjectArr['order']['field'] 	= 	'id';
			$SubjectArr['order']['type'] 	= 	'DESC';
		}
		elseif ($this->Section['subject_order'] == 3)
		{
			$SubjectArr['order']['field'] 	= 	'id';
			$SubjectArr['order']['type'] 	= 	'ASC';
		}
		else
		{
			$SubjectArr['order']['field'] 	= 	'write_time';
			$SubjectArr['order']['type'] 	= 	'DESC';
		}


		$SubjectArr['proc'] 						= 	array();
		// Ok Mr.XSS go to hell !
		$SubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
		$SubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
		$SubjectArr['proc']['write_time'] 			= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);



		// Pager setup
		$SubjectArr['pager'] 				= 	array();
		$SubjectArr['pager']['total']		= 	$PowerBB->core->GetNumber($TotalArr,'subject');
		$SubjectArr['pager']['perpage'] 	= 	$PowerBB->_CONF['info_row']['subject_perpage'];
		$SubjectArr['pager']['count'] 		= 	$PowerBB->_GET['count'];
		$SubjectArr['pager']['location'] 	= 	'index.php?page=forum&amp;show=1&amp;id=' . $this->Section['id'] . $password;
		$SubjectArr['pager']['var'] 		= 	'count';

		$PowerBB->_CONF['template']['while']['subject_list'] = $PowerBB->core->GetList($SubjectArr,'subject');



      /* Show part of the topic for a pause on the link
			$sectionid = $this->Section['id'];
			$SubjectTextArr = $PowerBB->DB->sql_query("SELECT  *   FROM " . $PowerBB->table['subject'] . " WHERE section = '$sectionid' ");

       while ($getstyleText = $PowerBB->DB->sql_fetch_array($SubjectTextArr))
       {

        $PowerBB->template->assign('subject_text',$getstyleText['text']);

       }

       */

		//////////

		$StickSubjectArr = array();

		$StickSubjectArr['where'] 				= 	array();

		$StickSubjectArr['where'][0] 			= 	array();
		$StickSubjectArr['where'][0]['name'] 	= 	'section';
		$StickSubjectArr['where'][0]['oper'] 	= 	'=';
		$StickSubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

		$StickSubjectArr['where'][1] 			= 	array();
		$StickSubjectArr['where'][1]['con']		=	'AND';
		$StickSubjectArr['where'][1]['name'] 	= 	'stick';
		$StickSubjectArr['where'][1]['oper'] 	= 	'=';
		$StickSubjectArr['where'][1]['value'] 	= 	'1';

		$StickSubjectArr['where'][2] 			= 	array();
		$StickSubjectArr['where'][2]['con']		=	'AND';
		$StickSubjectArr['where'][2]['name'] 	= 	'review_subject';
		$StickSubjectArr['where'][2]['oper'] 	= 	'<>';
		$StickSubjectArr['where'][2]['value'] 	= 	'1';
        if (!$PowerBB->functions->ModeratorCheck($this->Section['id']))
   		{
		$StickSubjectArr['where'][3] 			= 	array();
		$StickSubjectArr['where'][3]['con']		=	'AND';
		$StickSubjectArr['where'][3]['name'] 	= 	'delete_topic';
		$StickSubjectArr['where'][3]['oper'] 	= 	'<>';
		$StickSubjectArr['where'][3]['value'] 	= 	'1';
		}

		if ($this->Section['hide_subject']
		and ! $PowerBB->functions->ModeratorCheck($this->Section['id']))
		{
		$StickSubjectArr['where'][3] 			= 	array();
		$StickSubjectArr['where'][3]['con'] 		= 	'AND';
		$StickSubjectArr['where'][3]['name'] 	= 	'writer';
		$StickSubjectArr['where'][3]['oper'] 	= 	'=';
		$StickSubjectArr['where'][3]['value'] 	= 	$PowerBB->_CONF['member_row']['username'];
		}

		$StickSubjectArr['order'] = array();
		$StickSubjectArr['order']['field'] 	= 	'write_time';
		$StickSubjectArr['order']['type'] 	= 	'DESC';

		$StickSubjectArr['proc'] 						= 	array();
		// Ok Mr.XSS go to hell !
		$StickSubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
		$StickSubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
		$StickSubjectArr['proc']['write_time'] 			= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);

		$PowerBB->_CONF['template']['while']['stick_subject_list'] = $PowerBB->core->GetList($StickSubjectArr,'subject');

		if (sizeof($PowerBB->_CONF['template']['while']['stick_subject_list']) <= 0)
		{
			$PowerBB->template->assign('NO_STICK_SUBJECTS',true);
		}
		else
		{
			$PowerBB->template->assign('NO_STICK_SUBJECTS',false);
		}

		//////////

		// Get the list of subjects that need review
				 $username = $PowerBB->_CONF['member_row']['username'];
			     $SUBJECTS_review_subject_mem = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT * FROM " . $PowerBB->table['subject'] . " WHERE section = ".$PowerBB->_GET['id']." AND writer='$username' AND review_subject='1' "));

			 if ($PowerBB->functions->ModeratorCheck($this->Section['id']))
			 {
				$ReviewSubjectArr = array();

				$ReviewSubjectArr['where'] 				= 	array();

				$ReviewSubjectArr['where'][0] 			= 	array();
				$ReviewSubjectArr['where'][0]['name'] 	= 	'section';
				$ReviewSubjectArr['where'][0]['oper'] 	= 	'=';
				$ReviewSubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

				$ReviewSubjectArr['where'][1] 			= 	array();
				$ReviewSubjectArr['where'][1]['con']	=	'AND';
				$ReviewSubjectArr['where'][1]['name'] 	= 	'review_subject';
				$ReviewSubjectArr['where'][1]['oper'] 	= 	'=';
				$ReviewSubjectArr['where'][1]['value'] 	= 	'1';

				$ReviewSubjectArr['where'][2] 			= 	array();
				$ReviewSubjectArr['where'][2]['con']	=	'AND';
				$ReviewSubjectArr['where'][2]['name'] 	= 	'delete_topic';
				$ReviewSubjectArr['where'][2]['oper'] 	= 	'<>';
				$ReviewSubjectArr['where'][2]['value'] 	= 	'1';

					if ($this->Section['hide_subject']
					and ! $PowerBB->functions->ModeratorCheck($this->Section['id']))
				{
					$ReviewSubjectArr['where'][3] 			= 	array();
					$ReviewSubjectArr['where'][3]['con'] 		= 	'AND';
					$ReviewSubjectArr['where'][3]['name'] 	= 	'writer';
					$ReviewSubjectArr['where'][3]['oper'] 	= 	'=';
					$ReviewSubjectArr['where'][3]['value'] 	= 	$PowerBB->_CONF['member_row']['username'];
				}

				$ReviewSubjectArr['order'] 				= 	array();
				$ReviewSubjectArr['order']['field'] 	= 	'write_time';
				$ReviewSubjectArr['order']['type'] 		= 	'DESC';

				$ReviewSubjectArr['proc'] 						= 	array();
				// Ok Mr.XSS go to hell !
				$ReviewSubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
				$ReviewSubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
				$ReviewSubjectArr['proc']['write_time'] 		= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);

				$PowerBB->_CONF['template']['while']['review_subject_list'] = $PowerBB->subject->GetSubjectList($ReviewSubjectArr);

				if (sizeof($PowerBB->_CONF['template']['while']['review_subject_list']) <= 0)
				{
					$PowerBB->template->assign('NO_REVIEW_SUBJECTS',true);
				}
				else
				{
					$PowerBB->template->assign('NO_REVIEW_SUBJECTS',false);
				}
			 }
			elseif ($SUBJECTS_review_subject_mem>0)
			{

					$ReviewSubjectArr = array();

					$ReviewSubjectArr['where'] 				= 	array();

					$ReviewSubjectArr['where'][0] 			= 	array();
					$ReviewSubjectArr['where'][0]['name'] 	= 	'section';
					$ReviewSubjectArr['where'][0]['oper'] 	= 	'=';
					$ReviewSubjectArr['where'][0]['value'] 	= 	$this->Section['id'];

					$ReviewSubjectArr['where'][1] 			= 	array();
					$ReviewSubjectArr['where'][1]['con']	=	'AND';
					$ReviewSubjectArr['where'][1]['name'] 	= 	'review_subject';
					$ReviewSubjectArr['where'][1]['oper'] 	= 	'=';
					$ReviewSubjectArr['where'][1]['value'] 	= 	'1';

					$ReviewSubjectArr['where'][2] 			= 	array();
					$ReviewSubjectArr['where'][2]['con']	=	'AND';
					$ReviewSubjectArr['where'][2]['name'] 	= 	'writer';
					$ReviewSubjectArr['where'][2]['oper'] 	= 	'=';
					$ReviewSubjectArr['where'][2]['value'] 	= 	$PowerBB->_CONF['member_row']['username'];

					$ReviewSubjectArr['order'] 				= 	array();
					$ReviewSubjectArr['order']['field'] 	= 	'write_time';
					$ReviewSubjectArr['order']['type'] 		= 	'DESC';

					$ReviewSubjectArr['proc'] 						= 	array();
					// Ok Mr.XSS go to hell !
					$ReviewSubjectArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
					$ReviewSubjectArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
					$ReviewSubjectArr['proc']['write_time'] 		= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);

					$PowerBB->_CONF['template']['while']['review_subject_list'] = $PowerBB->subject->GetSubjectList($ReviewSubjectArr);

					if (sizeof($PowerBB->_CONF['template']['while']['review_subject_list']) <= 0)
					{
						$PowerBB->template->assign('NO_REVIEW_SUBJECTS',true);
					}
					else
					{
						$PowerBB->template->assign('NO_REVIEW_SUBJECTS',false);
					}

			}
			else
			{
				$PowerBB->template->assign('NO_REVIEW_SUBJECTS',true);
			}
		//////////

		if ($PowerBB->subject->GetSubjectNumber($TotalArr) > $PowerBB->_CONF['info_row']['subject_perpage'])
		{
		$PowerBB->template->assign('pager',$PowerBB->pager->show());
		}

		$PowerBB->template->assign('section_id',$this->Section['id']);
		}




	}

    /**
	 * Get the results of search one section
	 */

	function _SearchSection()
	{
		global $PowerBB;

         if (!$PowerBB->_GET['keyword'])
	      {
            $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['please_enter_a_single_search']);
	      }

		//////////

		$keyword 	= 	(isset($PowerBB->_GET['keyword'])) ? $PowerBB->_GET['keyword'] : $PowerBB->_POST['keyword'];
		$section 	= 	(isset($PowerBB->_GET['section'])) ? $PowerBB->_GET['section'] : $PowerBB->_POST['section'];
     	 $section 	= 	(isset($PowerBB->_GET['section'])) ? $PowerBB->_GET['section'] : $PowerBB->_POST['section'];

       if ($section != is_numeric($section))
		{
           $PowerBB->functions->ShowHeader();
		   $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['no_search_results']);
		 }

          	$subject_nm = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['subject'] . " WHERE text LIKE '%$keyword%' AND section = '$section'"));


            $sec = ' AND section =  ';

	          if ($subject_nm > '0')
	          {
		       $PowerBB->functions->msg($PowerBB->_CONF['template']['_CONF']['lang']['Search_successful']);
		       $PowerBB->functions->redirect('index.php?page=forum&amp;option=1&amp;section=' . $section . '&amp;keyword=' . $keyword);
	           }
		      else
		       {
		       $stop = ($PowerBB->_CONF['info_row']['ajax_search'] and !$PowerBB->_POST['ajax']) ? false : true;
			   $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['no_search_results'],$stop);
		       }

    }
	function _StartSearch()
	{
		global $PowerBB;

		if (!$PowerBB->_CONF['group_info']['search_allow'])
		{
          if (!$PowerBB->_CONF['member_permission'])
              {
              $PowerBB->template->display('login');
              $PowerBB->functions->error_stop();
			}
	        else
	        {
	        $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['no_online']);
	        }
	     }

         if (!$PowerBB->_GET['keyword'])
	      {
            $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['please_enter_a_single_search']);
	      }


           $PowerBB->_GET['count'] = (!isset($PowerBB->_GET['count'])) ? 0 : $PowerBB->_GET['count'];
           $PowerBB->_GET['count'] = $PowerBB->functions->CleanVariable($PowerBB->_GET['count'],'intval');
		//////////

		$keyword 	= 	(isset($PowerBB->_GET['keyword'])) ? $PowerBB->_GET['keyword'] : $PowerBB->_POST['keyword'];
		$section 	= 	(isset($PowerBB->_GET['section'])) ? $PowerBB->_GET['section'] : $PowerBB->_POST['section'];
      	$section	= 	$PowerBB->functions->CleanVariable($section,'intval');


       if ($section != is_numeric($section))
		{
           $PowerBB->functions->ShowHeader();
		   $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['no_search_results']);
		 }


          	$subject_nm = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['subject'] . " WHERE text LIKE '%$keyword%' AND section = '$section'"));

                $PowerBB->template->assign('nm',$subject_nm);

            $sec = ' AND section =  ';

            $SubjectSearchArr = array();

			$SubjectSearchArr['where'] 				= 	array();

			$SubjectSearchArr['where'][0] 			= 	array();
			$SubjectSearchArr['where'][0]['name'] 	= 	'text LIKE ';
			$SubjectSearchArr['where'][0]['oper']		=  "'".'%' .$keyword .'%'."'  $sec";
			$SubjectSearchArr['where'][0]['value']    =  $section;


			$SubjectSearchArr['proc'] 						= 	array();
			// Ok Mr.XSS go to hell !
			$SubjectSearchArr['proc']['*'] 					= 	array('method'=>'clean','param'=>'html');
			$SubjectSearchArr['proc']['native_write_time'] 	= 	array('method'=>'date','store'=>'write_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
			$SubjectSearchArr['proc']['write_time'] 			= 	array('method'=>'date','store'=>'reply_date','type'=>$PowerBB->_CONF['info_row']['timesystem']);
            // Pager setup
			$SubjectSearchArr['pager'] 				= 	array();
			$SubjectSearchArr['pager']['total']		= 	$subject_nm;
			$SubjectSearchArr['pager']['perpage'] 	= 	$PowerBB->_CONF['info_row']['perpage'];
			$SubjectSearchArr['pager']['count'] 	= 	$PowerBB->_GET['count'];
			$SubjectSearchArr['pager']['location'] 	= 	'index.php?page=forum&amp;option=1&amp;section=' . $section . '&amp;keyword=' . $keyword . '&amp;password=' . $PowerBB->_GET['password'];
			$SubjectSearchArr['pager']['var'] 		= 	'count';

			$PowerBB->_CONF['template']['while']['SubjectList'] = $PowerBB->core->GetList($SubjectSearchArr,'subject');

       if (($PowerBB->_CONF['template']['while']['SubjectList'] or $PowerBB->_CONF['template']['while']['ReplyList']  or $PowerBB->_CONF['template']['while']['SubjectTitleList'] or $PowerBB->_CONF['template']['while']['MembersListSubject'] or $PowerBB->_CONF['template']['while']['MembersListReply']  and !$this->SectionGroup['view_section']) == false)
	   {
		   $PowerBB->functions->error($PowerBB->_CONF['template']['_CONF']['lang']['No_search_results'],$stop);

       }



		$PowerBB->_CONF['template']['while']['SearchResult'] = $PowerBB->search->Search(array(	'keyword'	=>	$keyword,
															'section'	=>	$section));

       $ReplyArr['where'] = array($field,$PowerBB->_POST['keyword']);



		//////////

                	if ($subject_nm > $PowerBB->_CONF['info_row']['perpage'])
			        {
							$PowerBB->template->assign('pager','1');

			        }

		$PowerBB->template->assign('keyword',$keyword);
		$PowerBB->template->display('search_results_all');



	}


	function _CallTemplate()
	{
		global $PowerBB;

		$SecArr 			= 	array();
		$SecArr['where'] 	= 	array('id',$this->Section['id']);

		$Inf = $PowerBB->core->GetInfo($SecArr,'section');

        $PowerBB->template->assign('section_id',$this->Section['id']);

        //if subjects numprs in Section = 0 get the masseg
	   $SUBJECTS_NUM_IN_Forum = $PowerBB->DB->sql_num_rows($PowerBB->DB->sql_query("SELECT id FROM " . $PowerBB->table['subject'] . " WHERE section = ".$PowerBB->_GET['id']." AND delete_topic<>1"));
       $PowerBB->template->assign('NO_SUBJECTS',$SUBJECTS_NUM_IN_Forum);
         ////

         // Moderator And admin Check for View the Icons Editing and Deletion
		$ModArr 			= 	array();
		$ModArr['where'] 	= 	array('section_id',$PowerBB->_GET['id']);

		$ModeratorInfo = $PowerBB->core->GetInfo($ModArr,'moderators');

		if ($PowerBB->functions->ModeratorCheck($PowerBB->_GET['id']))
		{
			$PowerBB->template->assign('mod_toolbar',0);
			$PowerBB->template->assign('colspan',7);
		}
		else
		{
			$PowerBB->template->assign('mod_toolbar',1);
			$PowerBB->template->assign('colspan',6);
		}

        $SecSubject1 			= 	array();
		$SecSubject1['where'] 	= 	array('id',$Inf['parent']);

		$Section_rwo1 = $PowerBB->core->GetInfo($SecSubject1,'section');

        $SecSubject2 			= 	array();
		$SecSubject2['where'] 	= 	array('id',$Section_rwo1['parent']);

		$Section_rwo2 = $PowerBB->core->GetInfo($SecSubject2,'section');

      $PowerBB->template->assign('SectionGroup',$this->SectionGroup);
	 $PowerBB->template->assign('sec_address_id',$Section_rwo1['id']);
      $PowerBB->template->assign('section_parent',$Section_rwo1['parent']);
      $PowerBB->template->assign('sec_address_title',$Section_rwo1['title']);
      $PowerBB->template->assign('sec_main_title',$Section_rwo2['title']);
	 $PowerBB->template->assign('sec_main_id',$Section_rwo2['id']);

		$PowerBB->template->display('forum');

	}

	    /**
	 * Get the Jump Sections List
	 */
	function _GetJumpSectionsList()
    {
		global $PowerBB;

       $PowerBB->functions->JumpForumsList();
		//////////
       $PowerBB->template->display('jump_forums_list');


   }

}

?>